#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "kboard.h"
#include "loadLanguage.h"
#include <string.h>

extern Window keyboard_window;


void
on_togglebutton_shift_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
	shifttoggled = gtk_toggle_button_get_active((GtkToggleButton*) button);
	printf("Toggled %d \n",shifttoggled);
}

void
on_button_save_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	//reset all no_lower no_upper and recalculate all keysyms
	//and call writeUserLang()
    int i, j, k, entryarr[47], entryindex=0, len;
    gchar *p;
	gunichar uni;

	getModifiableKeyIds(entryarr);
	entryindex = 47;

	for(i=0; i<entryindex; i++) {
		j = entryarr[i];
		
		len = g_utf8_strlen(keys[j].lang.lower, KEYBOARD_VW_LENGTH) + 1;
		p = keys[j].lang.lower;
		for(k=0; k<len && k<MAX_CHARS_ON_KEY; k++) {
			uni = g_utf8_get_char(p);
			if (uni > 0xFF)
				uni = uni | 0x01000000;
			keys[j].lang.keysym_lower[k] = uni;
			p = g_utf8_find_next_char(p,&keys[j].lang.lower[KEYBOARD_VW_LENGTH - 1] );
		}
		keys[j].lang.no_lower = len;

		len = g_utf8_strlen(keys[j].lang.upper, KEYBOARD_VW_LENGTH) + 1;
        p = keys[j].lang.upper;
        for(k=0; k<len && k<MAX_CHARS_ON_KEY; k++) {
			uni = g_utf8_get_char(p);
			if (uni > 0xFF)
				uni = uni | 0x01000000;
            keys[j].lang.keysym_upper[k] = uni;
            p = g_utf8_find_next_char(p,&keys[j].lang.upper[KEYBOARD_VW_LENGTH - 1] );
		}
		keys[j].lang.no_upper = len;
	}
	writeUserLang();

	//printf("\n\non_button_save_clicked CALLED toggleShift %d \n\n",
	//		gtk_toggle_button_get_active((GtkToggleButton*) entryShift) );
}


void
on_eazykeyboard_destroy               (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


gboolean
on_eazykeyboard_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_main_quit();
  return FALSE;
}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	 gtk_widget_show (help_about);
}


void
on_quit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();

}


void
on_togglebutton_shift_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{	
	int i, j, entryarr[47], entryindex=0;

	ulangchange = TRUE;
	
	getModifiableKeyIds(entryarr);
	entryindex = 47;
	
	/*
	printf("\n\n on_togglebutton_shift_toggled CALLED toggleshift %d\n\n",
			gtk_toggle_button_get_active((GtkToggleButton*) entryShift) );

	if( gtk_toggle_button_get_active((GtkToggleButton*) entryShift) ) 
			printf("toggle shift button is active\n");
	else
			printf("toggle shift button is NOT active\n");

	
	for(i=0; i<entryindex; i++) {
		j = entryarr[i];
		printf(" NS %s  %d %s  S  %s  %d  %s\n",keys[j].kname1, keys[j].lang.no_lower, keys[j].lang.lower,
											keys[j].kname2, keys[j].lang.no_upper, keys[j].lang.upper);
	}*/
	
	for(i=0; i<entryindex; i++) 
	{
		j = entryarr[i];
		if( gtk_toggle_button_get_active((GtkToggleButton*) entryShift) ) 
		{
			gtk_button_set_label((GtkButton*) keys[j].button, (gchar*)keys[j].lang.upper);	
			gtk_entry_set_text((GtkEntry*) keys[j].entry, (gchar*)keys[j].lang.upper);
			kb_state = 1;
			//printf("ACTIVE %d  %s %s  \n",keys[j].lang.no_upper, keys[j].kname2, keys[j].lang.upper);
			
		}
		else 
		{
			gtk_button_set_label((GtkButton*) keys[j].button, (gchar*)keys[j].lang.lower);
			gtk_entry_set_text((GtkEntry*) keys[j].entry, (gchar*)keys[j].lang.lower);
			kb_state = 0;
			//printf("NOT ACTIVE %d  %s %s  \n",keys[j].lang.no_lower, keys[j].kname1, keys[j].lang.lower);
		}
	}
	
	ulangchange = FALSE;
}

gboolean
on_eazykeyboard_focus_in_event        (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
	Window winFocus;
	int revert_to_return;
	
    /* Trap the id of keyboard_window if focus is there for the first time */
	if ( keyboard_window == 0 )
	{
	
    	XGetInputFocus(GDK_DISPLAY(), &winFocus, &revert_to_return);
		keyboard_window = winFocus;
	}

  return FALSE;
}


void
on_show_status_bar_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    gint tw, th, w, h;
	
	///printf("on_show_status_bar_activate \n");
	gtk_window_get_size((GtkWindow*)topWindow, &w, &h);
	gtk_widget_get_size_request(topVBox, &tw, &th);
	
	if(isHideStatusBar) {
		gtk_widget_show_all(entry_status_bar);
		gtk_window_resize((GtkWindow*)topWindow, 
                  (gint)w, (gint) h + sbHeight);
		gtk_widget_set_size_request(topVBox, (gint)tw, (gint) th + sbHeight);
		isHideStatusBar = 0;
	}
	else {
		gtk_window_resize((GtkWindow*)topWindow, 
                  (gint)w, (gint) h - sbHeight);
		gtk_widget_set_size_request(topVBox,(gint)tw, (gint) th - sbHeight);
		gtk_widget_hide_all(entry_status_bar);	
		isHideStatusBar = 1;
	}		
}


void
on_show_entry_box_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	//printf("on_show_entry_box_activate\n\n");
    if( strcasecmp(cur_lang, "user") != 0)
		return;
	    
    if(! gtk_check_menu_item_get_active((GtkCheckMenuItem*) show_entry_box) )  {
		///printf("Hide Entries called\n");
        hideEntries();
    }
    else if(isHideEntry == 1) {
        ///printf("Show Entries called\n");
    	showEntries();
	}
			
}


void
on_button_closeAboutDialog_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	 gtk_widget_hide (help_about);
	 //printf("On close About Dialog clicked\n");
}

void
on_set_input_focus_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

