#include <gtk/gtk.h>
#include <string.h>
#include <X11/keysym.h>
#include <X11/XKBlib.h>
#include <X11/extensions/XKB.h>
#include <sys/time.h>
#include "kboard.h"
#include "loadLanguage.h"
#include "support.h"
#include "keycodes.h"

void mapKeys() {
	int i=0; 
	
	group = 0;

	entryShift = (GtkWidget*) lookup_widget(topWindow, "togglebutton_shift");
	//leftShift = (GtkWidget*) lookup_widget(topWindow, "button_leftShift");
	entrySave = (GtkWidget*) lookup_widget(topWindow, "button_save");
	
	cursorEntryWidget = (GtkWidget*) lookup_widget(topWindow,"label_cursorEntry");
	gtk_widget_hide_all(cursorEntryWidget);

	langMenuBar = (GtkWidget*) lookup_widget(topWindow, "languagemenu");
	show_entry_box = (GtkWidget*) lookup_widget(topWindow, "show_entry_box");
	show_status_bar = (GtkWidget*) lookup_widget(topWindow, "show_status_bar");
	set_input_focus = (GtkWidget*) lookup_widget(topWindow, "set_input_focus");
	entry_status_bar = (GtkWidget*) lookup_widget(topWindow, "entry_statusbar");
	keys[KEY_1].button = (GtkWidget*) lookup_widget(topWindow, "button_1");
	keys[KEY_1].entry = (GtkWidget*) lookup_widget(topWindow, "entry_1");
	strcpy(keys[KEY_1].kname1, "1"); strcpy(keys[KEY_1].kname2, "exclam");
	keys[KEY_2].button = (GtkWidget*) lookup_widget(topWindow, "button_2");
	keys[KEY_2].entry = (GtkWidget*) lookup_widget(topWindow, "entry_2");
	strcpy(keys[KEY_2].kname1, "2"); strcpy(keys[KEY_2].kname2, "at");
	keys[KEY_3].button = (GtkWidget*) lookup_widget(topWindow, "button_3");
	keys[KEY_3].entry = (GtkWidget*) lookup_widget(topWindow, "entry_3");
	strcpy(keys[KEY_3].kname1, "3"); strcpy(keys[KEY_3].kname2, "numbersign");
	keys[KEY_4].button = (GtkWidget*) lookup_widget(topWindow, "button_4");
	keys[KEY_4].entry = (GtkWidget*) lookup_widget(topWindow, "entry_4");
	strcpy(keys[KEY_4].kname1, "4"); strcpy(keys[KEY_4].kname2, "dollar");
	keys[KEY_5].button = (GtkWidget*) lookup_widget(topWindow, "button_5");
	keys[KEY_5].entry = (GtkWidget*) lookup_widget(topWindow, "entry_5");
	strcpy(keys[KEY_5].kname1, "5"); strcpy(keys[KEY_5].kname2, "percent");
	
	keys[KEY_6].button = (GtkWidget*) lookup_widget(topWindow, "button_6");
	keys[KEY_6].entry = (GtkWidget*) lookup_widget(topWindow, "entry_6");
	strcpy(keys[KEY_6].kname1, "6"); strcpy(keys[KEY_6].kname2, "asciicircum");
	keys[KEY_7].button = (GtkWidget*) lookup_widget(topWindow, "button_7");
	keys[KEY_7].entry = (GtkWidget*) lookup_widget(topWindow, "entry_7");
	strcpy(keys[KEY_7].kname1, "7"); strcpy(keys[KEY_7].kname2, "ampersand");
	keys[KEY_8].button = (GtkWidget*) lookup_widget(topWindow, "button_8");
	keys[KEY_8].entry = (GtkWidget*) lookup_widget(topWindow, "entry_8");
	strcpy(keys[KEY_8].kname1, "8"); strcpy(keys[KEY_8].kname2, "asterisk");
	keys[KEY_9].button = (GtkWidget*) lookup_widget(topWindow, "button_9");
	keys[KEY_9].entry = (GtkWidget*) lookup_widget(topWindow, "entry_9");
	strcpy(keys[KEY_9].kname1, "9"); strcpy(keys[KEY_9].kname2, "parenleft");
	keys[KEY_0].button = (GtkWidget*) lookup_widget(topWindow, "button_0");
	keys[KEY_0].entry = (GtkWidget*) lookup_widget(topWindow, "entry_0");
	strcpy(keys[KEY_0].kname1, "0"); strcpy(keys[KEY_0].kname2, "parenright");
	
	keys[KEY_A].button = (GtkWidget*) lookup_widget(topWindow, "button_a");
	keys[KEY_A].entry = (GtkWidget*) lookup_widget(topWindow, "entry_a");
	strcpy(keys[KEY_A].kname1, "a"); strcpy(keys[KEY_A].kname2, "A");
	keys[KEY_B].button = (GtkWidget*) lookup_widget(topWindow, "button_b");
	keys[KEY_B].entry = (GtkWidget*) lookup_widget(topWindow, "entry_b");
	strcpy(keys[KEY_B].kname1, "b"); strcpy(keys[KEY_B].kname2, "B");
	keys[KEY_C].button = (GtkWidget*) lookup_widget(topWindow, "button_c");
	keys[KEY_C].entry = (GtkWidget*) lookup_widget(topWindow, "entry_c");
	strcpy(keys[KEY_C].kname1, "c"); strcpy(keys[KEY_C].kname2, "C");
	keys[KEY_D].button = (GtkWidget*) lookup_widget(topWindow, "button_d");
	keys[KEY_D].entry = (GtkWidget*) lookup_widget(topWindow, "entry_d");
	strcpy(keys[KEY_D].kname1, "d"); strcpy(keys[KEY_D].kname2, "D");
	keys[KEY_E].button = (GtkWidget*) lookup_widget(topWindow, "button_e");
	keys[KEY_E].entry = (GtkWidget*) lookup_widget(topWindow, "entry_e");
	strcpy(keys[KEY_E].kname1, "e"); strcpy(keys[KEY_E].kname2, "E");
	
	keys[KEY_F].button = (GtkWidget*) lookup_widget(topWindow, "button_f");
	keys[KEY_F].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f");
	strcpy(keys[KEY_F].kname1, "f"); strcpy(keys[KEY_F].kname2, "F");
	keys[KEY_G].button = (GtkWidget*) lookup_widget(topWindow, "button_g");
	keys[KEY_G].entry = (GtkWidget*) lookup_widget(topWindow, "entry_g");
	strcpy(keys[KEY_G].kname1, "g"); strcpy(keys[KEY_G].kname2, "G");
	keys[KEY_H].button = (GtkWidget*) lookup_widget(topWindow, "button_h");
	keys[KEY_H].entry = (GtkWidget*) lookup_widget(topWindow, "entry_h");
	strcpy(keys[KEY_H].kname1, "h"); strcpy(keys[KEY_H].kname2, "H");
	keys[KEY_I].button = (GtkWidget*) lookup_widget(topWindow, "button_i");
	keys[KEY_I].entry = (GtkWidget*) lookup_widget(topWindow, "entry_i");
	strcpy(keys[KEY_I].kname1, "i"); strcpy(keys[KEY_I].kname2, "I");
	keys[KEY_J].button = (GtkWidget*) lookup_widget(topWindow, "button_j");
	keys[KEY_J].entry = (GtkWidget*) lookup_widget(topWindow, "entry_j");
	strcpy(keys[KEY_J].kname1, "j"); strcpy(keys[KEY_J].kname2, "J");

	keys[KEY_K].button = (GtkWidget*) lookup_widget(topWindow, "button_k");
	keys[KEY_K].entry = (GtkWidget*) lookup_widget(topWindow, "entry_k");
	strcpy(keys[KEY_K].kname1, "k"); strcpy(keys[KEY_K].kname2, "K");
	keys[KEY_L].button = (GtkWidget*) lookup_widget(topWindow, "button_l");
	keys[KEY_L].entry = (GtkWidget*) lookup_widget(topWindow, "entry_l");
	strcpy(keys[KEY_L].kname1, "l"); strcpy(keys[KEY_L].kname2, "L");
	keys[KEY_M].button = (GtkWidget*) lookup_widget(topWindow, "button_m");
	keys[KEY_M].entry = (GtkWidget*) lookup_widget(topWindow, "entry_m");
	strcpy(keys[KEY_M].kname1, "m"); strcpy(keys[KEY_M].kname2, "M");
	keys[KEY_N].button = (GtkWidget*) lookup_widget(topWindow, "button_n");
	keys[KEY_N].entry = (GtkWidget*) lookup_widget(topWindow, "entry_n");
	strcpy(keys[KEY_N].kname1, "n"); strcpy(keys[KEY_N].kname2, "N");
	keys[KEY_O].button = (GtkWidget*) lookup_widget(topWindow, "button_o");
	keys[KEY_O].entry = (GtkWidget*) lookup_widget(topWindow, "entry_o");
	strcpy(keys[KEY_O].kname1, "o"); strcpy(keys[KEY_O].kname2, "O");

	keys[KEY_P].button = (GtkWidget*) lookup_widget(topWindow, "button_p");
	keys[KEY_P].entry = (GtkWidget*) lookup_widget(topWindow, "entry_p");
	strcpy(keys[KEY_P].kname1, "p"); strcpy(keys[KEY_P].kname2, "P");
	keys[KEY_Q].button = (GtkWidget*) lookup_widget(topWindow, "button_q");
	keys[KEY_Q].entry = (GtkWidget*) lookup_widget(topWindow, "entry_q");
	strcpy(keys[KEY_Q].kname1, "q"); strcpy(keys[KEY_Q].kname2, "Q");
	keys[KEY_R].button = (GtkWidget*) lookup_widget(topWindow, "button_r");
	keys[KEY_R].entry = (GtkWidget*) lookup_widget(topWindow, "entry_r");
	strcpy(keys[KEY_R].kname1, "r"); strcpy(keys[KEY_R].kname2, "R");
	keys[KEY_S].button = (GtkWidget*) lookup_widget(topWindow, "button_s");
	keys[KEY_S].entry = (GtkWidget*) lookup_widget(topWindow, "entry_s");
	strcpy(keys[KEY_S].kname1, "s"); strcpy(keys[KEY_S].kname2, "S");
	keys[KEY_T].button = (GtkWidget*) lookup_widget(topWindow, "button_t");
	keys[KEY_T].entry = (GtkWidget*) lookup_widget(topWindow, "entry_t");
	strcpy(keys[KEY_T].kname1, "t"); strcpy(keys[KEY_T].kname2, "T");

	keys[KEY_U].button = (GtkWidget*) lookup_widget(topWindow, "button_u");
	keys[KEY_U].entry = (GtkWidget*) lookup_widget(topWindow, "entry_u");
	strcpy(keys[KEY_U].kname1, "u"); strcpy(keys[KEY_U].kname2, "U");
	keys[KEY_V].button = (GtkWidget*) lookup_widget(topWindow, "button_v");
	keys[KEY_V].entry = (GtkWidget*) lookup_widget(topWindow, "entry_v");
	strcpy(keys[KEY_V].kname1, "v"); strcpy(keys[KEY_V].kname2, "V");
	keys[KEY_W].button = (GtkWidget*) lookup_widget(topWindow, "button_w");
	keys[KEY_W].entry = (GtkWidget*) lookup_widget(topWindow, "entry_w");
	strcpy(keys[KEY_W].kname1, "w"); strcpy(keys[KEY_W].kname2, "W");
	keys[KEY_X].button = (GtkWidget*) lookup_widget(topWindow, "button_x");
	keys[KEY_X].entry = (GtkWidget*) lookup_widget(topWindow, "entry_x");
	strcpy(keys[KEY_X].kname1, "x"); strcpy(keys[KEY_X].kname2, "X");
	keys[KEY_Y].button = (GtkWidget*) lookup_widget(topWindow, "button_y");
	keys[KEY_Y].entry = (GtkWidget*) lookup_widget(topWindow, "entry_y");
	strcpy(keys[KEY_Y].kname1, "y"); strcpy(keys[KEY_Y].kname2, "Y");
	keys[KEY_Z].button = (GtkWidget*) lookup_widget(topWindow, "button_z");
	keys[KEY_Z].entry = (GtkWidget*) lookup_widget(topWindow, "entry_z");
	strcpy(keys[KEY_Z].kname1, "z"); strcpy(keys[KEY_Z].kname2, "Z");

	keys[KEY_ESC].button = (GtkWidget*) lookup_widget(topWindow, "button_esc");
	keys[KEY_ESC].entry = (GtkWidget*) lookup_widget(topWindow, "entry_esc");
	strcpy(keys[KEY_ESC].kname1, "Escape"); strcpy(keys[KEY_ESC].kname2, "Escape");

	keys[KEY_F1].button = (GtkWidget*) lookup_widget(topWindow, "button_f1");
	keys[KEY_F1].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f1");
	strcpy(keys[KEY_F1].kname1, "F1"); strcpy(keys[KEY_F1].kname2, "F1");
	keys[KEY_F2].button = (GtkWidget*) lookup_widget(topWindow, "button_f2");
	keys[KEY_F2].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f2");
	strcpy(keys[KEY_F2].kname1, "F2"); strcpy(keys[KEY_F2].kname2, "F2");
	keys[KEY_F3].button = (GtkWidget*) lookup_widget(topWindow, "button_f3");
	keys[KEY_F3].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f3");
	strcpy(keys[KEY_F3].kname1, "F3"); strcpy(keys[KEY_F3].kname2, "F3");
	keys[KEY_F4].button = (GtkWidget*) lookup_widget(topWindow, "button_f4");
	keys[KEY_F4].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f4");
	strcpy(keys[KEY_F4].kname1, "F4"); strcpy(keys[KEY_F4].kname2, "F4");
	keys[KEY_F5].button = (GtkWidget*) lookup_widget(topWindow, "button_f5");
	keys[KEY_F5].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f5");
	strcpy(keys[KEY_F5].kname1, "F5"); strcpy(keys[KEY_F5].kname2, "F5");

	keys[KEY_F6].button = (GtkWidget*) lookup_widget(topWindow, "button_f6");
	keys[KEY_F6].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f6");
	strcpy(keys[KEY_F6].kname1, "F6"); strcpy(keys[KEY_F6].kname2, "F6");
	keys[KEY_F7].button = (GtkWidget*) lookup_widget(topWindow, "button_f7");
	keys[KEY_F7].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f7");
	strcpy(keys[KEY_F7].kname1, "F7"); strcpy(keys[KEY_F7].kname2, "F7");
	keys[KEY_F8].button = (GtkWidget*) lookup_widget(topWindow, "button_f8");
	keys[KEY_F8].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f8");
	strcpy(keys[KEY_F8].kname1, "F8"); strcpy(keys[KEY_F8].kname2, "F8");
	keys[KEY_F9].button = (GtkWidget*) lookup_widget(topWindow, "button_f9");
	keys[KEY_F9].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f9");
	strcpy(keys[KEY_F9].kname1, "F9"); strcpy(keys[KEY_F9].kname2, "F9");
	keys[KEY_F10].button = (GtkWidget*) lookup_widget(topWindow, "button_f10");
	keys[KEY_F10].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f10");
	strcpy(keys[KEY_F10].kname1, "F10"); strcpy(keys[KEY_F10].kname2, "F10");

	keys[KEY_F11].button = (GtkWidget*) lookup_widget(topWindow, "button_f11");
	keys[KEY_F11].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f11");
	strcpy(keys[KEY_F11].kname1, "F11"); strcpy(keys[KEY_F11].kname2, "F11");
	keys[KEY_F12].button = (GtkWidget*) lookup_widget(topWindow, "button_f12");
	keys[KEY_F12].entry = (GtkWidget*) lookup_widget(topWindow, "entry_f12");
	strcpy(keys[KEY_F12].kname1, "F12"); strcpy(keys[KEY_F12].kname2, "F12");

	keys[KEY_TILDE].button = (GtkWidget*) lookup_widget(topWindow, "button_tilde");
	keys[KEY_TILDE].entry = (GtkWidget*) lookup_widget(topWindow, "entry_tilde");
	strcpy(keys[KEY_TILDE].kname1, "grave"); 
	strcpy(keys[KEY_TILDE].kname2, "asciitilde");
	keys[KEY_MINUS].button = (GtkWidget*) lookup_widget(topWindow, "button_minus");
	keys[KEY_MINUS].entry = (GtkWidget*) lookup_widget(topWindow, "entry_minus");
	strcpy(keys[KEY_MINUS].kname1, "minus"); 
	strcpy(keys[KEY_MINUS].kname2, "underscore");
	keys[KEY_EQUAL].button = (GtkWidget*) lookup_widget(topWindow, "button_equal");
	keys[KEY_EQUAL].entry = (GtkWidget*) lookup_widget(topWindow, "entry_equal");
	strcpy(keys[KEY_EQUAL].kname1, "equal"); strcpy(keys[KEY_EQUAL].kname2, "plus");
	keys[KEY_BACKSPACE].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_backspace");
	keys[KEY_BACKSPACE].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_backspace");
	strcpy(keys[KEY_BACKSPACE].kname1, "BackSpace"); 
	strcpy(keys[KEY_BACKSPACE].kname2, "BackSpace");
	keys[KEY_OPENBRACKET].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_openBracket");
	keys[KEY_OPENBRACKET].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_openBracket");
	strcpy(keys[KEY_OPENBRACKET].kname1, "bracketleft"); 
	strcpy(keys[KEY_OPENBRACKET].kname2, "braceleft");
	keys[KEY_CLOSEBRACKET].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_closeBracket");
	keys[KEY_CLOSEBRACKET].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_closeBracket");
	strcpy(keys[KEY_CLOSEBRACKET].kname1, "bracketright"); 
	strcpy(keys[KEY_CLOSEBRACKET].kname2, "braceright");
	keys[KEY_BACKSLASH].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_backSlash");
	keys[KEY_BACKSLASH].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_backSlash");
	strcpy(keys[KEY_BACKSLASH].kname1, "backslash"); 
	strcpy(keys[KEY_BACKSLASH].kname2, "bar");
	keys[KEY_SEMICOLON].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_semiColon");
	keys[KEY_SEMICOLON].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_semiColon");
	strcpy(keys[KEY_SEMICOLON].kname1, "semicolon"); 
	strcpy(keys[KEY_SEMICOLON].kname2, "colon");
	keys[KEY_QUOTE].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_singleQuote");
	keys[KEY_QUOTE].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_singleQuote");
	strcpy(keys[KEY_QUOTE].kname1, "apostrophe"); 
	strcpy(keys[KEY_QUOTE].kname2, "quotedbl");
	keys[KEY_ENTER].button = (GtkWidget*) lookup_widget(topWindow, 
													"button_enter");
	keys[KEY_ENTER].entry = (GtkWidget*) lookup_widget(topWindow, 
													"entry_enter");
	strcpy(keys[KEY_ENTER].kname1, "Return"); strcpy(keys[KEY_ENTER].kname2, "Return");
	
	keys[KEY_LEFTSHIFT].button = (GtkWidget*) lookup_widget(topWindow,"button_leftShift");
	keys[KEY_LEFTSHIFT].entry = (GtkWidget*) lookup_widget(topWindow, "entry_leftShift");
	strcpy(keys[KEY_LEFTSHIFT].kname1, "Shift_L"); 
	strcpy(keys[KEY_LEFTSHIFT].kname2, "Shift_L");
	
	keys[KEY_COMMA].button = (GtkWidget*) lookup_widget(topWindow, "button_comma");
	keys[KEY_COMMA].entry = (GtkWidget*) lookup_widget(topWindow, "entry_comma");
	strcpy(keys[KEY_COMMA].kname1, "comma"); strcpy(keys[KEY_COMMA].kname2, "less");
	keys[KEY_POINT].button = (GtkWidget*) lookup_widget(topWindow, "button_point");
	keys[KEY_POINT].entry = (GtkWidget*) lookup_widget(topWindow, "entry_point");
	strcpy(keys[KEY_POINT].kname1, "period"); strcpy(keys[KEY_POINT].kname2, "greater");
	keys[KEY_SLASH].button = (GtkWidget*) lookup_widget(topWindow, "button_slash");
	keys[KEY_SLASH].entry = (GtkWidget*) lookup_widget(topWindow, "entry_slash");
	strcpy(keys[KEY_SLASH].kname1, "slash"); strcpy(keys[KEY_SLASH].kname2, "question");
	keys[KEY_RIGHTSHIFT].button = (GtkWidget*) lookup_widget(topWindow,"button_rightShift");
	keys[KEY_RIGHTSHIFT].entry = (GtkWidget*) lookup_widget(topWindow,"entry_rightShift");
	strcpy(keys[KEY_RIGHTSHIFT].kname1, "Shift_R"); 
	strcpy(keys[KEY_RIGHTSHIFT].kname2, "Shift_R");
	keys[KEY_LEFTCTRL].button = (GtkWidget*) lookup_widget(topWindow, 
														"button_leftCtrl");
	keys[KEY_LEFTCTRL].entry = (GtkWidget*) lookup_widget(topWindow, 
														"entry_leftCtrl");
	strcpy(keys[KEY_LEFTCTRL].kname1, "Control_L"); 
	strcpy(keys[KEY_LEFTCTRL].kname2, "Control_L");
	keys[KEY_LEFTALT].button = (GtkWidget*) lookup_widget(topWindow, 
															"button_leftAlt");
	keys[KEY_LEFTALT].entry = (GtkWidget*) lookup_widget(topWindow, 
															"entry_leftAlt");
	strcpy(keys[KEY_LEFTALT].kname1, "Alt_L"); strcpy(keys[KEY_LEFTALT].kname2, "Alt_L");
	keys[KEY_SPACE].button = (GtkWidget*) lookup_widget(topWindow, "button_space");
	keys[KEY_SPACE].entry = (GtkWidget*) lookup_widget(topWindow, "entry_space");
	strcpy(keys[KEY_SPACE].kname1, "space"); strcpy(keys[KEY_SPACE].kname2, "space");
	keys[KEY_RIGHTALT].button = (GtkWidget*) lookup_widget(topWindow, 
															"button_rightAlt");
	keys[KEY_RIGHTALT].entry = (GtkWidget*) lookup_widget(topWindow, 
															"entry_rightAlt");
	strcpy(keys[KEY_RIGHTALT].kname1, "Alt_R"); strcpy(keys[KEY_RIGHTALT].kname2, "Alt_R");
	keys[KEY_RIGHTCTRL].button = (GtkWidget*) lookup_widget(topWindow, 
															"button_rightCtrl");
	keys[KEY_RIGHTCTRL].entry = (GtkWidget*) lookup_widget(topWindow, 
														"entry_rightCtrl");
	strcpy(keys[KEY_RIGHTCTRL].kname1, "Control_R"); 
	strcpy(keys[KEY_RIGHTCTRL].kname2, "Control_R");
	
	keys[KEY_INSERT].button = (GtkWidget*) lookup_widget(topWindow, "button_insert");
	//keys[KEY_INSERT].entry = (GtkWidget*) lookup_widget(topWindow, "entry_insert");
	strcpy(keys[KEY_INSERT].kname1, "Insert"); 
	strcpy(keys[KEY_INSERT].kname2, "Insert");
	
	keys[KEY_HOME].button = (GtkWidget*) lookup_widget(topWindow, "button_home");
	//keys[KEY_HOME].entry = (GtkWidget*) lookup_widget(topWindow, "entry_home");
	strcpy(keys[KEY_HOME].kname1, "Home"); 
	strcpy(keys[KEY_HOME].kname2, "Home");
	
	keys[KEY_PAGEUP].button = (GtkWidget*) lookup_widget(topWindow, "button_pageUp");
	//keys[KEY_PAGEUP].entry = (GtkWidget*) lookup_widget(topWindow, "entry_pageUp");
	strcpy(keys[KEY_PAGEUP].kname1, "Prior"); 
	strcpy(keys[KEY_PAGEUP].kname2, "Prior");
	
	keys[KEY_DELETE].button = (GtkWidget*) lookup_widget(topWindow, "button_delete");
	//keys[KEY_DELETE].entry = (GtkWidget*) lookup_widget(topWindow, "entry_delete");
	strcpy(keys[KEY_DELETE].kname1, "Delete"); 
	strcpy(keys[KEY_DELETE].kname2, "Delete");
	
	keys[KEY_END].button = (GtkWidget*) lookup_widget(topWindow, "button_end");
	//keys[KEY_END].entry = (GtkWidget*) lookup_widget(topWindow, "entry_end");
	strcpy(keys[KEY_END].kname1, "End"); 
	strcpy(keys[KEY_END].kname2, "End");
	
	keys[KEY_PAGEDOWN].button = (GtkWidget*) lookup_widget(topWindow, "button_pageDown");
	//keys[KEY_PAGEDOWN].entry = (GtkWidget*) lookup_widget(topWindow, "entry_pageDown");
	strcpy(keys[KEY_PAGEDOWN].kname1, "Next"); 
	strcpy(keys[KEY_PAGEDOWN].kname2, "Next");
	
	keys[KEY_UPARROW].button = (GtkWidget*) lookup_widget(topWindow, "button_upArrow");
	//keys[KEY_UPARROW].entry = (GtkWidget*) lookup_widget(topWindow, "entry_upArrow");
	strcpy(keys[KEY_UPARROW].kname1, "Up"); 
	strcpy(keys[KEY_UPARROW].kname2, "Up");
	
	keys[KEY_LEFTARROW].button = (GtkWidget*) lookup_widget(topWindow, "button_leftArrow");
	//keys[KEY_LEFTARROW].entry = (GtkWidget*) lookup_widget(topWindow, "entry_leftArrow");
	strcpy(keys[KEY_LEFTARROW].kname1, "Left"); 
	strcpy(keys[KEY_LEFTARROW].kname2, "Left");
	
	keys[KEY_DOWNARROW].button = (GtkWidget*) lookup_widget(topWindow, "button_downArrow");
	//keys[KEY_DOWNARROW].entry = (GtkWidget*) lookup_widget(topWindow, "entry_downArrow");
	strcpy(keys[KEY_DOWNARROW].kname1, "Down"); 
	strcpy(keys[KEY_DOWNARROW].kname2, "Down");
	
	keys[KEY_RIGHTARROW].button = (GtkWidget*) lookup_widget(topWindow, "button_rightArrow");
	//keys[KEY_RIGHTARROW].entry = (GtkWidget*) lookup_widget(topWindow, "entry_rightArrow");
	strcpy(keys[KEY_RIGHTARROW].kname1, "Right"); 
	strcpy(keys[KEY_RIGHTARROW].kname2, "Right");
	
	/*get the height & widhts of window, vbox and hbox & get ratios*/
	topVBox=0; entriesHBox=0;
	topVBox = (GtkWidget*) lookup_widget(topWindow, "vbox1");
	entriesHBox = (GtkWidget*) lookup_widget(topWindow, "hbox19");

	gtk_window_get_size((GtkWindow*)topWindow, &tWinw, &tWinh);
	gtk_widget_get_size_request(topVBox, &tVBw, &tVBh);
	gtk_widget_get_size_request(entriesHBox, &eHBw, &eHBh);
	
	vbox_w_ratio = 1 - (1.0*eHBw/tVBw);
	vbox_h_ratio = 1 - (1.0*eHBh/tVBh);
	
	win_w_ratio = 1 - (1.0*eHBw/tWinw);
	win_h_ratio = 1 - (1.0*eHBh/tWinh);
	
	/*Initially since entries are hidden resize the window */
	gtk_widget_set_size_request(topVBox,
					(gint)tVBw, (gint)(tVBh*vbox_h_ratio));
	gtk_window_resize((GtkWindow*)topWindow,
					(gint)tWinw, (gint)(tWinh*win_h_ratio));

	/*set default button style for all keys*/
	for(i=1; i<NO_OF_KEYS; i++) {
		gtk_widget_set_style (GTK_WIDGET (keys[i].button), 
							gtk_widget_get_default_style ());
	}
	
	/*assign Key types*/
	for(i=KEY_A; i<=KEY_Z; i++)
		keys[i].kflag = KEYBOARD_KEYS;	
	for(i=KEY_0; i<=KEY_9; i++)
		keys[i].kflag = KEYBOARD_KEYS;

	keys[KEY_TILDE].kflag = keys[KEY_MINUS].kflag = KEYBOARD_KEYS;
	keys[KEY_EQUAL].kflag = KEYBOARD_KEYS;
	keys[KEY_OPENBRACKET].kflag = keys[KEY_CLOSEBRACKET].kflag= KEYBOARD_KEYS; 
	keys[KEY_BACKSLASH].kflag = KEYBOARD_KEYS;		
	keys[KEY_SEMICOLON].kflag = keys[KEY_QUOTE].kflag = KEYBOARD_KEYS;
	keys[KEY_COMMA].kflag = keys[KEY_POINT].kflag =	KEYBOARD_KEYS;
	keys[KEY_SLASH].kflag = KEYBOARD_KEYS;
	
	keys[KEY_SPACE].kflag = KEYBOARD_SPACE;
	keys[KEY_BACKSPACE].kflag = KEYBOARD_BACKSPACE;
	keys[KEY_ENTER].kflag = KEYBOARD_RETURN;
	keys[KEY_ESC].kflag = KEYBOARD_ESCAPE;
	
	keys[KEY_LEFTSHIFT].kflag = keys[KEY_RIGHTSHIFT].kflag = KEYBOARD_ETC;
	keys[KEY_LEFTCTRL].kflag = keys[KEY_RIGHTCTRL].kflag= KEYBOARD_ETC;
	keys[KEY_LEFTALT].kflag = keys[KEY_RIGHTALT].kflag = KEYBOARD_ETC;
	for(i=KEY_F1; i<=KEY_F12; i++)
		keys[i].kflag = KEYBOARD_KEYS;

	for(i=KEY_PAGEKEYSTART; i<=KEY_PAGEKEYEND; i++)
		keys[i].kflag = KEYBOARD_KEYS;
	
	setKeysymSpecialKeys();

	shift = ctrl = alt = 0;	
	kb_total_key = 0;
	kb_state = 0;

	ulangchange = TRUE;

	isHideEntry = 1;
	isHideStatusBar = 0;
	gtk_widget_get_size_request(entry_status_bar, &sbWidth, &sbHeight);
	XDisplayKeycodes(GDK_DISPLAY(), &min_keycode, &max_keycode);
	loadKeycodes();
}

int shift_toggled_callback (GtkButton *button, gpointer data) 
{
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
  {
     gtk_widget_set_sensitive(GTK_WIDGET(data),FALSE);     
     kb_state = kb_state | ShiftMask;
     key_press_shift();
  }     
  else
  { 
     gtk_widget_set_sensitive(GTK_WIDGET(data),TRUE); 
     kb_state = 0; 
     key_release_shift();
  }	  
  return TRUE; 	  
}


int ctrl_toggled_callback (GtkButton *button, gpointer data) 
{
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
  {
	kb_state = kb_state | ControlMask;
	ctrl = 4; 
  }
  else
  {
  	kb_state = ctrl = 0;	    
  }
  return TRUE; 	  
}

int alt_toggled_callback (GtkButton *button, gpointer data) 
{
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
  {
	kb_state = kb_state | Mod1Mask;
	alt = 8; 
  }
  else
  {
  	kb_state = alt = 0;	    
  }
  return TRUE; 	  
}


void signalsConnect() 
{
	int i=0;
	int entryarr[47], entryindex=0;

	/*connect physical keyboard's keypress  & release event*/
  	gtk_signal_connect (GTK_OBJECT (topWindow), "key_press_event",
						GTK_SIGNAL_FUNC (topWindow_key_press_callback), NULL);
  	gtk_signal_connect (GTK_OBJECT (topWindow), "key_release_event",
						GTK_SIGNAL_FUNC (topWindow_key_release_callback), NULL);
  
	//connect all buttons for press & release events	
	for(i=KEY_COUNT_START; i<=KEY_COUNT_END; i++) 
	{
	  if(i==60) 
	  {
	   gtk_signal_connect (GTK_OBJECT (keys[i].button), 
							"toggled",
							GTK_SIGNAL_FUNC (shift_toggled_callback), 
							keys[64].button); 
     	  }
	  else if(i==64)  
	  {
	   gtk_signal_connect (GTK_OBJECT (keys[i].button), 
							"toggled",
							GTK_SIGNAL_FUNC (shift_toggled_callback), 
							keys[60].button);  
     	  }
	  else if(i == 65 || i == 68)
	  {
	     gtk_signal_connect (GTK_OBJECT (keys[i].button), 
							"toggled",
							GTK_SIGNAL_FUNC (ctrl_toggled_callback), 
							NULL);  
	  }
	  else if(i == 66 || i == 69)
	  {
	     gtk_signal_connect (GTK_OBJECT (keys[i].button), 
							"toggled",
							GTK_SIGNAL_FUNC (alt_toggled_callback), 
							NULL);
  	  }
	  else
	  {
		gtk_signal_connect (GTK_OBJECT (keys[i].button), 
							"button_press_event",
							GTK_SIGNAL_FUNC (button_key_press_callback), 
							&keys[i]);
		gtk_signal_connect (GTK_OBJECT (keys[i].button), 
							"button_release_event", 
							GTK_SIGNAL_FUNC (button_key_release_callback), 
							&keys[i]);
	  } 			
	}

	/*connect all only manipulable entries for changed event 
	 * to simulteneously manipulate button lable */	
	getModifiableKeyIds(entryarr);
	entryindex = 47;
	
	for(i=0; i<entryindex; i++) {
		//set the maximum length of chars in entry to MAX_CHARS_ON_KEY
		gtk_entry_set_max_length(keys[ entryarr[i] ].entry, MAX_CHARS_ON_KEY);
		//connect the signal 
		gtk_signal_connect (GTK_OBJECT (keys[ entryarr[i] ].entry), 
							"changed", 
							GTK_SIGNAL_FUNC (key_b_entry_changed_callback), 
							&keys[ entryarr[i] ]);
	}
}


int button_key_press_callback (GtkButton *button, GdkEvent *event, key *cur_k)
{
	///printf("button pressed id : %s  %s", cur_k->lang.upper, cur_k->lang.lower); 
	gchar str_sent[KEYBOARD_VW_LENGTH];
	KeySym keysym[3];
	int nkeysym, i;
	GdkEventButton *gdk_buttonevent;
	gdk_buttonevent = (GdkEventButton *)event;

	GtkStyle *keyboard_s;
	keyboard_s = gtk_style_new ();
	keyboard_s->bg[0].red = 255;
	//keyboard_s->bg[0].green = 0;
	//keyboard_s->bg[0].blue = 0;
	gtk_widget_set_style (GTK_WIDGET(cur_k->button), keyboard_s);

	//printf("event origin = %s\n", (event==NULL) ? "MAIN WINDOW":"SELF");

	//if (event->type == GDK_BUTTON_PRESS)
	//	kb_state = ((GdkEventButton*)event)->state & 0xFF; 
	//	// take only keyboard flags in lower 8 bits
	
	
	if ((kb_state & ShiftMask) || (shift==1) ) 
	{ // Shift key has been pressed
		sprintf(str_sent,"%s",cur_k->lang.upper);
		nkeysym = cur_k->lang.no_upper;
		for(i=0; i<nkeysym; i++)
			keysym[i] = cur_k->lang.keysym_upper[i];
			
	}
	
	else 
	{ // Shift key has not been pressed
		sprintf(str_sent,"%s",cur_k->lang.lower);
		nkeysym = cur_k->lang.no_lower;
		for(i=0; i<nkeysym; i++)
			keysym[i] = cur_k->lang.keysym_lower[i];
	}

	/* Redirect event */
	if (redirect_window)
	{
		XKeyEvent keyevent;

		GdkEventKey *gdk_keyevent;
		// GdkKeymapKey *gdk_keys;
		int n_keys;
		
		// KeySym *keyval, save_keyval;
		// int count, n_keyval;

		/* First set input focus to target window (BASED ON OPTION) because some 
		 * window accepts keyboard events only if input focus is in that window
		*/
		if( gtk_check_menu_item_get_active((GtkCheckMenuItem*) set_input_focus)) 
			
			XSetInputFocus(GDK_DISPLAY(), redirect_window, RevertToNone, CurrentTime); 
											// GDK_CURRENT_TIME); //fake_timestamp());

		for(i=0; i<nkeysym; i++) {
			/*
			if (gdk_keymap_get_entries_for_keyval(NULL, keysym[i], &gdk_keys, &n_keys) )
				printf("\nFound.  keycode=0x%X group=%d  state=0x%X", gdk_keys->keycode, gdk_keys->group, kb_state);
			*/

			keyevent.type        = KeyPress;
			keyevent.display     = GDK_DISPLAY();
			keyevent.window  	 = redirect_window;
			keyevent.root        = GDK_ROOT_WINDOW();
			keyevent.subwindow   = None;
			keyevent.same_screen = True;
			keyevent.state       = 0;
			keyevent.x = keyevent.y = keyevent.x_root = keyevent.y_root = 1;
			
			keyevent.keycode = XKeysymToKeycode(GDK_DISPLAY(), keysym[i]);
						
			/* Check and assign masks. */
			keyevent.state       = kb_state & 0xFF; // Take only flags in lower 8 bits
			
			if (XKeycodeToKeysym(GDK_DISPLAY(), keyevent.keycode, 0)
					== keysym[i])
				
				keyevent.state = keyevent.state & ~ShiftMask;
					
				
			if(strcasecmp(cur_lang, "System") == 0)
			{
				if (event->type == GDK_KEY_PRESS)
				{   // keyboard event
					gdk_keyevent = (GdkEventKey *)event;
					keyevent.state = ((GdkEventKey *)event)->state | shift | ctrl | alt; // & 0xFF;
					keyevent.keycode = gdk_keyevent->hardware_keycode;
					
				}
				else
				{
					//keyevent.state = ((GdkEventButton *)event)->state;
					keyevent.state = kb_state;
				}
				///printf("state=0x%X keycode=0x%X\n", keyevent.state, keyevent.keycode);
			}

			/*
			if (event->type == GDK_KEY_PRESS)
				keyevent.keycode = ((GdkEventKey*)event)->hardware_keycode;
			else
				keyevent.keycode = XKeysymToKeycode(GDK_DISPLAY(), keysym[i]);
			*/
						
			keyevent.time        = CurrentTime; // GDK_CURRENT_TIME; // fake_timestamp();

			// printf("\nPress: keycode=0x%X keysym=0x%X (%c)  kb_state=0x%X", keyevent.keycode, keysym[i], keysym[i], kb_state);
			// fflush(stdout);

			gdk_error_trap_push();      /* Catch errors, hopefully */
		
			/* This may produce a BadWindow error with Xlib.  Bummer. 
			 * This happens most commonly when the window that was selected
			 * to redirect to doesn't exist on screen anymore.
			 */
			XSendEvent(GDK_DISPLAY(), redirect_window, True,
							KeyPressMask, (XEvent *) &keyevent);
			


			/* Flush the X queue to catch errors now. */
			gdk_flush();

			if (gdk_error_trap_pop()) {
				fprintf(stderr, "BadWindow: Redirect window no longer exist\n");
				return TRUE;
			}
		}

		/* Now since key event has been sent to the target window, restore focus
		   back to our keyboard window
		*/
		if( gtk_check_menu_item_get_active((GtkCheckMenuItem*) set_input_focus)) 
			XSetInputFocus(GDK_DISPLAY(), keyboard_window, RevertToNone, CurrentTime); 
												// GDK_CURRENT_TIME); //fake_timestamp());

		
	}
	
	return TRUE;
}

int button_key_release_callback (GtkButton *button, 
				GdkEvent *event, key *cur_k) {

	//kb_state = kb_state | shift | ctrl | alt;
	///printf("	button released id : %s  %s\n", cur_k->kname1, cur_k->kname2);
	gtk_widget_set_style (GTK_WIDGET (cur_k->button), 
							gtk_widget_get_default_style ());
	if(shift == 1)
		key_release_shift();

	if(ctrl == 4)
	{
		if(gtk_toggle_button_get_active(keys[KEY_LEFTCTRL].button))
			gtk_toggle_button_set_active(keys[KEY_LEFTCTRL].button,FALSE);
		if(gtk_toggle_button_get_active(keys[KEY_RIGHTCTRL].button)) 
			gtk_toggle_button_set_active(keys[KEY_RIGHTCTRL].button,FALSE);
	}
	
	if(alt == 8)
	{
		if(gtk_toggle_button_get_active(keys[KEY_LEFTALT].button))
			gtk_toggle_button_set_active(keys[KEY_LEFTALT].button,FALSE);
		if(gtk_toggle_button_get_active(keys[KEY_RIGHTALT].button)) 
			gtk_toggle_button_set_active(keys[KEY_RIGHTALT].button,FALSE);
	}
	
	///printf("\nRelease: kb_state=0x%X", kb_state);
	fflush(stdout);

	return TRUE;
}

gboolean topWindow_key_press_callback(GtkWidget *window, 
				GdkEventKey *event, gpointer user_data) {
	int i=0;
	
	if(! isHideEntry ) return FALSE; //if entry table is shown don't execute it may 
							 //be just label manipulation in user type.	
	
	if (! event->keyval) return TRUE;
	
	//g_print("event->keyval = %s event->state = %d Mod1Mask = %d\n",gdk_keyval_name(event->keyval),event->state,Mod1Mask);

	if (event->state)
		kb_state = event->state;
	else
		kb_state = 0;
	
	
	// printf("keyval name=%s\n", gdk_keyval_name(event->keyval));
	if (event->keyval == GDK_Alt_L || event->keyval == GDK_Alt_R)
		if ( !(kb_state & Mod1Mask) )
			kb_state = kb_state | Mod1Mask;
			
	//kb_state = 8
	
	if (event->keyval == GDK_Control_L || event->keyval == GDK_Control_R)
		if ( !(kb_state & ControlMask) )
			kb_state = kb_state | ControlMask;

	if (event->keyval == GDK_Mode_switch)
	{
		if (! (kb_state & 0x2000) )
		{
			group = 1;
			defaultKeyboard();
			kb_state = kb_state | 0x2000;
		}
	}
	
	if (event->keyval == GDK_Shift_L || event->keyval == GDK_Shift_R) {
		
		if (! (kb_state & ShiftMask) )
		{
			kb_state = kb_state | ShiftMask;
			key_press_shift();
		}
	}

	
	for(i=KEY_COUNT_START;i<=KEY_COUNT_END; i++) {
		if(keys[i].keycode == event->hardware_keycode ) {
			button_key_press_callback(GTK_BUTTON(keys[i].button),event,&keys[i]);
			break;
		}	
	}
	
	return FALSE;	
}

gboolean topWindow_key_release_callback(GtkWidget *window, 
				GdkEventKey *event, gpointer user_data) {
	int i=0;
	
	/*	For system type keyboard 
	 * 	We need to check if the previous group and current group is same or not
	 * 	if it is not then store that as current state. This group identification will be 
	 * 	used in case of system type keyboard.
	 * 	Group is indicated by 13th & 14th bit status in key state
	*/
	
	if (event->keyval != GDK_Mode_switch)
	{
		int bit13=0, bit14=0, group1=0;

		group1 = (((GdkEventKey *)event)->state & 0x6000) >> 13;
		
		
		/*
		if( 8192 & ((GdkEventKey *)event)->state ) bit13=1; //is 13th bit on
		if( 16384 & ((GdkEventKey *)event)->state ) bit14=1; //is 14th bit on
		
		if((bit13==0) && (bit14==0)) group1 = 0;
		if((bit13==1) && (bit14==0)) group1 = 1;
		if((bit13==0) && (bit14==1)) group1 = 2;
		if((bit13==1) && (bit14==1)) group1 = 3;
		*/
		
		if(group != group1) {
			group = group1;
			if(strcasecmp(cur_lang, "System") == 0)
			{
				if (group)
				{
					kb_state = kb_state | (group << 13);
					
				}
				else
				{
					kb_state = kb_state & 0xCFFF;
					
				}
				defaultKeyboard();
			}
		}
	}
	
	/*
	printf("13th bit %d\n", ( 8192 & ((GdkEventKey *)event)->state )?1:0);
	printf("14th bit %d\n", ( 16384 & ((GdkEventKey *)event)->state )?1:0);
	*/

	if(! isHideEntry ) return FALSE; //if entry table is shown don't execute it may 
							 //be just label manipulation in user type.	
	if (! event->keyval) return TRUE;
	
	if (event->state && (event->keyval == GDK_Alt_L || event->keyval == GDK_Alt_R))
		if (kb_state & Mod1Mask)
			kb_state = kb_state & ~Mod1Mask;
	
	
	if (event->state && (event->keyval == GDK_Control_L || event->keyval == GDK_Control_R))
		if (kb_state & ControlMask)
			kb_state = kb_state & ~ControlMask;
	
	
	if (event->keyval == GDK_Mode_switch)
	{
		if (kb_state & 0x2000)
		{
			kb_state = kb_state & ~0x2000;
			group = 0;
			defaultKeyboard();
			
		}
	}
	
	if (event->keyval == GDK_Shift_L || event->keyval == GDK_Shift_R) {
		if (kb_state & ShiftMask) {
			kb_state = kb_state & ~ShiftMask; 
			key_release_shift();
		}
	}
	// printf("\ngroup=%d kb_state=0x%X", group, kb_state);
	
	for(i=KEY_COUNT_START;i<=KEY_COUNT_END; i++) {
		if(keys[i].keycode == event->hardware_keycode ) {
			button_key_release_callback(GTK_BUTTON(keys[i].button),event,&keys[i]);
			break;
		}	
	}
	
	return FALSE;
}

int key_b_entry_changed_callback(GtkEditable *editable, key *cur_k) {
	int i, len;
	gchar *p;
	gunichar uni;
	
	if(ulangchange == TRUE)   //If this call is due to user lang change  
		return TRUE;		  // do not change just return.
	
	if(strcasecmp(cur_lang, "user") != 0) //if its not user lang dont change
		return TRUE;	//anyway entry boxes will not be visible in other langs
						//so no need this can be removed.
	
	//Check user_e_changed from onscreen for shift and utf_unicode	
	gtk_button_set_label( (GtkButton*)cur_k->button,
	 			gtk_entry_get_text((GtkEntry*)cur_k->entry));	
		
	if( gtk_toggle_button_get_active((GtkToggleButton*) entryShift) )  {
		g_utf8_strncpy(cur_k->lang.upper, 
					gtk_entry_get_text((GtkEntry*)cur_k->entry), MAX_CHARS_ON_KEY);
		len = g_utf8_strlen(cur_k->lang.upper, KEYBOARD_VW_LENGTH) + 1;
		p = cur_k->lang.upper;
		for(i=0; i<len && i<MAX_CHARS_ON_KEY; i++) {
			uni = g_utf8_get_char(p);
			if (uni > 0xFF)
				uni = uni | 0x01000000;
			cur_k->lang.keysym_upper[i] = uni;
			p = g_utf8_find_next_char(p, &cur_k->lang.upper[KEYBOARD_VW_LENGTH - 1]);
		}
		cur_k->lang.no_upper = len;		
	}
	else {
		g_utf8_strncpy(cur_k->lang.lower, 
					gtk_entry_get_text((GtkEntry*)cur_k->entry), MAX_CHARS_ON_KEY);
		len = g_utf8_strlen(cur_k->lang.lower, KEYBOARD_VW_LENGTH) + 1;
		p = cur_k->lang.lower;
		for(i=0; i<len && i<MAX_CHARS_ON_KEY; i++) {
			uni = g_utf8_get_char(p);
			if (uni > 0xFF)
				uni = uni | 0x01000000;
			cur_k->lang.keysym_lower[i] = uni;
			p = g_utf8_find_next_char(p, &cur_k->lang.lower[KEYBOARD_VW_LENGTH - 1]);
		}
		cur_k->lang.no_lower = len;
	}

	return TRUE;
}

void showEntries() {
	gint tw, th, bw, bh, w, h;
	int i, j, entryindex, entryarr[47];
	
	if(isHideEntry) {
		//first set all button label and entry text to that of 
		//toggle shift position 
		getModifiableKeyIds(entryarr);
		entryindex = 47;
		for(i=0; i<entryindex; i++) {
			j = entryarr[i];
			if( gtk_toggle_button_get_active((GtkToggleButton*) entryShift) ) {
				gtk_button_set_label((GtkButton*) keys[j].button, keys[j].lang.upper);
				gtk_entry_set_text((GtkEntry*) keys[j].entry, keys[j].lang.upper);
			}
			else {
				gtk_button_set_label((GtkButton*) keys[j].button, keys[j].lang.lower);
				gtk_entry_set_text((GtkEntry*) keys[j].entry, keys[j].lang.lower);
			}

			gtk_widget_set_sensitive((GtkWidget*)keys[j].entry, TRUE);
		}	
		
		gtk_window_get_size((GtkWindow*)topWindow, &w, &h);
		gtk_widget_get_size_request(topVBox, &tw, &th);
		gtk_widget_get_size_request(entriesHBox, &bw, &bh);
		
		gtk_window_resize((GtkWindow*)topWindow,
						(gint)w, (gint)(h/win_h_ratio + 0.5));
		//	gtk_widget_set_size_request(topVBox,
		//				(gint)tw, (gint)(th+(tw/hratio + 0.5)));
		
		//if show entry menu item is not on set it
///		if(! gtk_check_menu_item_get_active((GtkCheckMenuItem *)view_menu_items[0]) ) 
///			gtk_check_menu_item_set_active( (GtkCheckMenuItem *)view_menu_items[0], TRUE);
		if(! gtk_check_menu_item_get_active((GtkCheckMenuItem*) show_entry_box)) 
			gtk_check_menu_item_set_active((GtkCheckMenuItem*) show_entry_box, TRUE);
		if( gtk_toggle_button_get_active((GtkToggleButton*) entryShift) ) 
			kb_state = 1;
		else
			kb_state = 0;
		gtk_toggle_button_set_active(keys[KEY_LEFTSHIFT].button, FALSE);
		gtk_toggle_button_set_active(keys[KEY_RIGHTSHIFT].button, FALSE);

		gtk_widget_set_sensitive(keys[KEY_LEFTSHIFT].button, FALSE);
		gtk_widget_set_sensitive(keys[KEY_RIGHTSHIFT].button, FALSE);
		
		gtk_widget_show_all (entriesHBox);	
		gtk_widget_show_all(cursorEntryWidget);
	}
	isHideEntry = 0;
	
}


void hideEntries() {
	gint tw, th, bw, bh, w, h;
	int i, j, entryindex, entryarr[47];
	
	if(! isHideEntry) {	
			
		//first set all button's lables to lower case (it might be in upper case)
		//when toggle shift of entry was on and then hide
		getModifiableKeyIds(entryarr);
		entryindex = 47;
		for(i=0; i<entryindex; i++) {
			j = entryarr[i];
			gtk_button_set_label((GtkButton*) keys[j].button, keys[j].lang.lower);
			gtk_widget_set_sensitive((GtkWidget*)keys[j].entry, FALSE);
		}	
			
		gtk_window_get_size((GtkWindow*)topWindow, &w, &h);
		gtk_widget_get_size_request(topVBox, &tw, &th);
		gtk_widget_get_size_request(entriesHBox, &bw, &bh);

		gtk_widget_hide_all (entriesHBox);
		gtk_window_resize((GtkWindow*)topWindow,
						(gint)w, (gint)(h*win_h_ratio + 0.5));
		gtk_widget_set_size_request(topVBox,
						(gint)tw, (gint)(th*vbox_h_ratio + 0.5));
		//if hide entry menu item is not on set it
///		if(! gtk_check_menu_item_get_active((GtkCheckMenuItem *)view_menu_items[1]) ) 
///			gtk_check_menu_item_set_active( (GtkCheckMenuItem *)view_menu_items[1], TRUE);
		if( gtk_check_menu_item_get_active((GtkCheckMenuItem*) show_entry_box)) 
			gtk_check_menu_item_set_active((GtkCheckMenuItem*) show_entry_box, FALSE);

		gtk_widget_hide_all(cursorEntryWidget);
		//	gtk_widget_set_size_request(topVBox,(gint)tw, (gint)(th-eHBh));

		gtk_widget_set_sensitive(keys[KEY_LEFTSHIFT].button, TRUE);
		gtk_widget_set_sensitive(keys[KEY_RIGHTSHIFT].button, TRUE);
		gtk_toggle_button_set_active(keys[KEY_LEFTSHIFT].button, FALSE);
		gtk_toggle_button_set_active(keys[KEY_RIGHTSHIFT].button, FALSE);
	}
	isHideEntry = 1;
	kb_state = 0;
}

void setLangMenu() {
	int i;
	langMenu = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (langMenuBar), langMenu);
	
	lang_menu_items = (GtkWidget**) malloc(no_of_langs * sizeof(GtkWidget *));
	
	for(i=0; i<no_of_langs; i++) {
		lang_menu_items[i] = gtk_radio_menu_item_new_with_label 
								(lang_menu_group, langNames[i]);
	
		lang_menu_group = gtk_radio_menu_item_group 
						(GTK_RADIO_MENU_ITEM(lang_menu_items[i]));
		gtk_widget_show (lang_menu_items[i]);
		gtk_container_add (GTK_CONTAINER (langMenu), lang_menu_items[i]);
		
		if(i == 0)
			gtk_check_menu_item_set_active 
  				(GTK_CHECK_MENU_ITEM (lang_menu_items[i]), TRUE);
		
		gtk_signal_connect (GTK_OBJECT (lang_menu_items[i]), 
							"activate",
							GTK_SIGNAL_FUNC (language_changed_callback),
							langNames[i]);
	}
}

void language_changed_callback(GtkMenuItem	 *menuitem,
								gpointer	   user_data)
{
	int i=0;
	//Check all radio buttons and see which is active
	//get its label which is lang name and accorgly 
	//langid from (index of matching langNames) 
	//call setCurrentLang(langid);
	///printf("Language changed\n");
	if (GTK_CHECK_MENU_ITEM (menuitem)->active) {
		for(i=0; i<no_of_langs; i++)
			if(strcmp(langNames[i], (char*)user_data) == 0) {
				///printf("Current language = %s\n",(char *)user_data);
				cur_lang_id = i;
				strcpy(cur_lang, (char*)user_data);
				setCurrentLang(cur_lang_id);
				break;
			}
	}
}


void key_press_shift() 
{
	//Change all buttons labels to upper case
	int i, j;		
	int entryarr[47], entryindex=47;
	shift=1;
	
	getModifiableKeyIds(entryarr);
	entryindex = 47;
		
	for(i=0; i<entryindex; i++) {
		j = entryarr[i];
		gtk_button_set_label((GtkButton*)keys[j].button, keys[j].lang.upper);	
		//gtk_entry_set_text((GtkEntry*) keys[j].entry, keys[j].lang.upper);
	}
	
}

void key_release_shift() 
{
	//Change back all buttons labels to small case
	int i, j;
	int entryarr[47], entryindex=0;
	shift=0;
	
	getModifiableKeyIds(entryarr);
	entryindex = 47;
	
	for(i=0; i<entryindex; i++) {
		j = entryarr[i];
		gtk_button_set_label((GtkButton*)keys[j].button, keys[j].lang.lower);
		//gtk_entry_set_text((GtkEntry*) keys[j].entry, keys[j].lang.upper);
		
	} 
	if(gtk_toggle_button_get_active(keys[KEY_LEFTSHIFT].button))
		gtk_toggle_button_set_active(keys[KEY_LEFTSHIFT].button,FALSE);
	if(gtk_toggle_button_get_active(keys[KEY_RIGHTSHIFT].button)) 
		gtk_toggle_button_set_active(keys[KEY_RIGHTSHIFT].button,FALSE);
	
}

static Time fake_timestamp() {
	int  tint;
	struct timeval  tv;
	struct timezone tz; /* is not used since ages */
	gettimeofday(&tv, &tz);
	tint = (int)tv.tv_sec * 1000;
	tint = tint/1000 * 1000;
	tint = tint + tv.tv_usec/1000;
	return((Time)tint);
} /* End fake_timestamp() */


void setKeysymSpecialKeys() {
	int i;
	KeySym fkeysym;
	
	keys[KEY_ESC].lang.no_lower = 1;
	keys[KEY_ESC].lang.no_upper = 1;
	keys[KEY_ESC].lang.keysym_lower[0] = XK_Escape;
	keys[KEY_ESC].lang.keysym_upper[0] = XK_Escape;
	
	fkeysym = XK_F1;
	for(i=KEY_F1; i<=KEY_F12; i++) {
		keys[i].lang.no_lower = 1;
		keys[i].lang.no_upper = 1;
		keys[i].lang.keysym_lower[0] = fkeysym;
		keys[i].lang.keysym_upper[0] = fkeysym;
		fkeysym += 1;
	}
	
	keys[KEY_ENTER].lang.no_lower = 1;
	keys[KEY_ENTER].lang.no_upper = 1;
	keys[KEY_ENTER].lang.keysym_lower[0] = XK_Return;
	keys[KEY_ENTER].lang.keysym_upper[0] = XK_Return;
	
	keys[KEY_LEFTSHIFT].lang.no_lower = 1;
	keys[KEY_LEFTSHIFT].lang.no_upper = 1;
	keys[KEY_LEFTSHIFT].lang.keysym_lower[0] = XK_Shift_L;
	keys[KEY_LEFTSHIFT].lang.keysym_upper[0] = XK_Shift_L;
	
	keys[KEY_RIGHTSHIFT].lang.no_lower = 1;
	keys[KEY_RIGHTSHIFT].lang.no_upper = 1;
	keys[KEY_RIGHTSHIFT].lang.keysym_lower[0] = XK_Shift_R;
	keys[KEY_RIGHTSHIFT].lang.keysym_upper[0] = XK_Shift_R;
	
	keys[KEY_LEFTCTRL].lang.no_lower = 1;
	keys[KEY_LEFTCTRL].lang.no_upper = 1;
	keys[KEY_LEFTCTRL].lang.keysym_lower[0] = XK_Control_L;
	keys[KEY_LEFTCTRL].lang.keysym_upper[0] = XK_Control_L;
	
	keys[KEY_RIGHTCTRL].lang.no_lower = 1;
	keys[KEY_RIGHTCTRL].lang.no_upper = 1;
	keys[KEY_RIGHTCTRL].lang.keysym_lower[0] = XK_Control_R;
	keys[KEY_RIGHTCTRL].lang.keysym_upper[0] = XK_Control_R;
	
	keys[KEY_LEFTALT].lang.no_lower = 1;
	keys[KEY_LEFTALT].lang.no_upper = 1;
	keys[KEY_LEFTALT].lang.keysym_lower[0] = XK_Alt_L;
	keys[KEY_LEFTALT].lang.keysym_upper[0] = XK_Alt_L;
	
	keys[KEY_RIGHTALT].lang.no_lower = 1;
	keys[KEY_RIGHTALT].lang.no_upper = 1;
	keys[KEY_RIGHTALT].lang.keysym_lower[0] = XK_Alt_R;
	keys[KEY_RIGHTALT].lang.keysym_upper[0] = XK_Alt_R;
	
	keys[KEY_SPACE].lang.no_lower = 1;
	keys[KEY_SPACE].lang.no_upper = 1;
	keys[KEY_SPACE].lang.keysym_lower[0] = XK_space;
	keys[KEY_SPACE].lang.keysym_upper[0] = XK_space;
	
	keys[KEY_BACKSPACE].lang.no_lower = 1;
	keys[KEY_BACKSPACE].lang.no_upper = 1;
	keys[KEY_BACKSPACE].lang.keysym_lower[0] = XK_BackSpace;
	keys[KEY_BACKSPACE].lang.keysym_upper[0] = XK_BackSpace;
	
	keys[KEY_INSERT].lang.no_lower = 1;
	keys[KEY_INSERT].lang.no_upper = 1;
	keys[KEY_INSERT].lang.keysym_lower[0] = XK_Insert;
	keys[KEY_INSERT].lang.keysym_upper[0] = XK_Insert;
	
	keys[KEY_HOME].lang.no_lower = 1;
	keys[KEY_HOME].lang.no_upper = 1;
	keys[KEY_HOME].lang.keysym_lower[0] = XK_Home;
	keys[KEY_HOME].lang.keysym_upper[0] = XK_Home;
	
	keys[KEY_PAGEUP].lang.no_lower = 1;
	keys[KEY_PAGEUP].lang.no_upper = 1;
	keys[KEY_PAGEUP].lang.keysym_lower[0] = XK_Page_Up;
	keys[KEY_PAGEUP].lang.keysym_upper[0] = XK_Page_Up;
	
	keys[KEY_DELETE].lang.no_lower = 1;
	keys[KEY_DELETE].lang.no_upper = 1;
	keys[KEY_DELETE].lang.keysym_lower[0] = XK_Delete;
	keys[KEY_DELETE].lang.keysym_upper[0] = XK_Delete;
	
	keys[KEY_END].lang.no_lower = 1;
	keys[KEY_END].lang.no_upper = 1;
	keys[KEY_END].lang.keysym_lower[0] = XK_End;
	keys[KEY_END].lang.keysym_upper[0] = XK_End;
	
	keys[KEY_PAGEDOWN].lang.no_lower = 1;
	keys[KEY_PAGEDOWN].lang.no_upper = 1;
	keys[KEY_PAGEDOWN].lang.keysym_lower[0] = XK_Page_Down;
	keys[KEY_PAGEDOWN].lang.keysym_upper[0] = XK_Page_Down;
	
	keys[KEY_UPARROW].lang.no_lower = 1;
	keys[KEY_UPARROW].lang.no_upper = 1;
	keys[KEY_UPARROW].lang.keysym_lower[0] = XK_Up;
	keys[KEY_UPARROW].lang.keysym_upper[0] = XK_Up;
	
	keys[KEY_LEFTARROW].lang.no_lower = 1;
	keys[KEY_LEFTARROW].lang.no_upper = 1;
	keys[KEY_LEFTARROW].lang.keysym_lower[0] = XK_Left;
	keys[KEY_LEFTARROW].lang.keysym_upper[0] = XK_Left;
	
	keys[KEY_DOWNARROW].lang.no_lower = 1;
	keys[KEY_DOWNARROW].lang.no_upper = 1;
	keys[KEY_DOWNARROW].lang.keysym_lower[0] = XK_Down;
	keys[KEY_DOWNARROW].lang.keysym_upper[0] = XK_Down;
	
	keys[KEY_RIGHTARROW].lang.no_lower = 1;
	keys[KEY_RIGHTARROW].lang.no_upper = 1;
	keys[KEY_RIGHTARROW].lang.keysym_lower[0] = XK_Right;
	keys[KEY_RIGHTARROW].lang.keysym_upper[0] = XK_Right;
}

void getModifiableKeyIds(int *entryarr1) {
	int i, entryindex1=0;

	entryindex1 = 0;
	for(i=KEY_A ; i<=KEY_Z; i++)
			entryarr1[entryindex1++] = i;
	for(i=KEY_0 ; i<=KEY_9; i++)
			entryarr1[entryindex1++] = i;
	entryarr1[entryindex1++] = KEY_TILDE;
	entryarr1[entryindex1++] = KEY_MINUS;
	entryarr1[entryindex1++] = KEY_EQUAL;
	entryarr1[entryindex1++] = KEY_OPENBRACKET;
	entryarr1[entryindex1++] = KEY_BACKSLASH;
	entryarr1[entryindex1++] = KEY_CLOSEBRACKET;
	entryarr1[entryindex1++] = KEY_SLASH;
	entryarr1[entryindex1++] = KEY_SEMICOLON;
	entryarr1[entryindex1++] = KEY_QUOTE;
	entryarr1[entryindex1++] = KEY_COMMA;
	entryarr1[entryindex1++] = KEY_POINT;
	entryarr1[entryindex1++] = KEY_SLASH;					
}

void defaultKeyboard() {
	int keysym_per_keycode, keycode_count;
	KeySym *ksym;
	int outLower, outUpper, i, j, bytelen, kid;
	gunichar uni;

	//printf("\nIn defaultKeyboard Changing labels \n");	
	XDisplayKeycodes(GDK_DISPLAY(), &min_keycode, &max_keycode);
	//printf("MIN KEYCODE=%d   MAX KEYCODE=%d\n",min_keycode, max_keycode);

	//printf("GROUP = %d\n",group);

	keycode_count = max_keycode-min_keycode+1;	
        
	ksym = XGetKeyboardMapping(GDK_DISPLAY(), min_keycode, 
					keycode_count, &keysym_per_keycode);
	
	
	for(i=min_keycode, j=0; i<=max_keycode; i++, j++) {
		
		if( (kid = isModifiableKeys_code(i)) != 9999) {
			uni = ksym[j*keysym_per_keycode + 2*group] & 0xFFFF;
			bytelen = g_unichar_to_utf8(uni, keys[kid].lang.lower);
			
			keys[kid].lang.lower[bytelen] = '\0'; // Terminate with NULL
			keys[kid].lang.no_lower = 1;
			////keys[kid].lang.keysym_lower[0] = ksym[j*keysym_per_keycode];
			keys[kid].lang.keysym_lower[0] = ksym[j*keysym_per_keycode + 2*group];
			
			//keys[kid].lang_no_lower = g_utf8_strlen(keys[kid].lang.lower);
			//
			//It may be that in mem itself more than 1 strings may be mapped to a key
			//how r represented how to get different keysyms & string see.
			gtk_button_set_label( (GtkButton*)keys[kid].button, 
							(gchar *)keys[kid].lang.lower);

			//PROBLEM WE ARE NOT GETTING  keys[kid].lang.lower properly from 
			//g_unichar_to_utf8(uni, keys[kid].lang.lower) HAVE A LOOK
			
			//printf("button %s lable changed to %s\n",keys[kid].kname1, (gchar *)keys[kid].lang.lower);
			uni = ksym[j*keysym_per_keycode + 1 + 2*group] & 0xFFFF;
			bytelen = g_unichar_to_utf8(uni, keys[kid].lang.upper);
			keys[kid].lang.upper[bytelen] = '\0'; // Terminate with NULL
			
			keys[kid].lang.no_upper = 1;
			////keys[kid].lang.keysym_upper[0] = ksym[j*keysym_per_keycode + 1];
			keys[kid].lang.keysym_upper[0] = ksym[j*keysym_per_keycode + 1 + 2*group];
					
		}
	}
}

GdkFilterReturn pickNewKeyboardMap(GdkXEvent *xevent,
							GdkEvent *event,
							gpointer data) 
{
	//printf("\nIn filter event. event=%d", ((XEvent *)xevent)->type);
	//if (((XEvent *)xevent)->type == KeymapNotify) {
	if (((XEvent *)xevent)->type == MappingNotify) {
		//printf("%d \npickNewKeyboardMap: Keyboard map has changed.",((XEvent *)xevent)->type);
		fflush(stdout);
		if(strcasecmp(cur_lang, "System") == 0)
			defaultKeyboard();
	}
	/*	
	if (((XEvent *)xevent)->type == XkbStateNotify) {
		XkbStateNotifyEvent *xkbev;

		//printf("\npickNewKeyboardMap: XKB Keyboard state has changed.");
		xkbev = (XkbStateNotifyEvent *)xevent;
		///printf("\nXkbStateNotify group=%d Keycode=0x%X\n", xkbev->group, xkbev->keycode);
		//if (xkbev->changed & XkbGroupStateMask) 
		//	printf("\n0x%4X In particular group has been chnaged.", xkbev->changed & 0xFFFF);
		//fflush(stdout);
	}*/
	return GDK_FILTER_CONTINUE;
	//return GDK_FILTER_TRANSLATE;
	//return GDK_FILTER_REMOVE;
}

				
void showStatusBar() {
	
}

void hideStatusBar() {

}

int isModifiableKeys_code(guint16 kcode) {
	int i=0;
	for(i=KEY_A ; i<=KEY_Z; i++) {
		if(keys[i].keycode == kcode)
			return i;
	}
	for(i=KEY_0 ; i<=KEY_9; i++) {
		if(keys[i].keycode == kcode)
			return i;
	}
	
	if(keys[KEY_TILDE].keycode == kcode)
		return KEY_TILDE;
	else if(keys[KEY_MINUS].keycode == kcode) 
		return KEY_MINUS;
	else if(keys[KEY_EQUAL].keycode == kcode)
		return KEY_EQUAL;
	else if(keys[KEY_OPENBRACKET].keycode == kcode)
		return KEY_OPENBRACKET;
	else if(keys[KEY_BACKSLASH].keycode == kcode)
		return KEY_BACKSLASH;
	else if(keys[KEY_CLOSEBRACKET].keycode == kcode)
		return KEY_CLOSEBRACKET;
	else if(keys[KEY_SLASH].keycode == kcode)
		return KEY_SLASH;
	else if(keys[KEY_SEMICOLON].keycode == kcode)
		return KEY_SEMICOLON;
	else if(keys[KEY_QUOTE].keycode == kcode)
		return KEY_QUOTE;
	else if(keys[KEY_COMMA].keycode == kcode)
		return KEY_COMMA;
	else if(keys[KEY_POINT].keycode == kcode)
		return KEY_POINT;
	else
		return 9999;
}

gint track_focus(gpointer data) {

	char r_win_name[1500];
	Window winFocus;
	XEvent dummyEvent;
	static int executing = 0;
	static Window dummyWindow = 0;

	GdkWindow *main_keyboard_window = 0, *curr_window = 0;
	
	/*
	 *	Window root_win, parent_win;
	 *  unsigned int num_children;
	 *  Window *child_list = 0;
	 *
	 */

	int revert_to_return;
	static char *winName;
	gboolean success;
	
	if (executing)
		return TRUE;

	executing = 1; // set flag to avoid re-entry
	
	if (keyboard_window == 0) {
		executing = 0;
       	return TRUE;}

	/* find out which window currently has focus */
	XGetInputFocus(GDK_DISPLAY(), &winFocus, &revert_to_return);

	

	if (redirect_window && winFocus == last_found_window) {
		executing = 0;
		return TRUE;
	}
    last_found_window = winFocus;

    /*
	 *	if (!XQueryTree(GDK_DISPLAY(), winFocus, &root_win, 
	 *  &parent_win, &child_list, &num_children)) {
	 * 	 	executing = 0;
	 *  	return TRUE;
	 *  }
	 *                            
	 *  if (keyboard_window == parent_win) {
	 *  	executing = 0;
	 *      return TRUE;
	 *  }
	 *  
	 *  if (child_list) XFree((char *)child_list);
	 *  */

    /* If keyboard window is parent of the current focus window then
	 * simply return in order to avoid circular event loop
	 * */
    main_keyboard_window = gdk_window_lookup(keyboard_window);
    if ( GDK_IS_WINDOW(gdk_xid_table_lookup(winFocus)) )
		curr_window = gdk_window_lookup (winFocus);

    if (curr_window &&
	     main_keyboard_window == gdk_window_get_toplevel (curr_window)) {
			executing = 0;
			return TRUE;
	}
	
    /* Return if the window is the same or if it's the program
	 * window or if we can't redirect to that window.
	 *
	 * If there was a previous window that was any good, stick to
	 * that one.
	 */

	if(	winFocus == redirect_window  ||
		winFocus == keyboard_window  ||
		winFocus == None             ||
		winFocus == PointerRoot)
    {
        executing = 0;
        return TRUE;
    } /* End if */
		
    /* At this point, we know the window is "good" and that we want
	 * it's name.  We're going to use it as the redirect from now on.
	 */
	
	/* set up error trapping, in case we get a BadWindow error */
     gdk_error_trap_push();
	
	/* this could generate the error */
    success = XFetchName(GDK_DISPLAY(), winFocus, &winName);
	
	/* Flush the X queue to catch errors now. */
	gdk_flush ();

	if (gdk_error_trap_pop()) { 
		/* Oops...error.  Probably BadWindow */
         redirect_window = None; /* reset focus window */
         fprintf(stderr, "There was an error finding a valid redirect window.\n");
         return TRUE;  /* better luck next time */
	} /* End if */
	
    /* Grab the window definition */
    redirect_window = winFocus;

    if (winName)
        sprintf(r_win_name, "Redirect Window Name: %s  [ID: 0x%X]", 
						winName, redirect_window);
    else
        sprintf(r_win_name, "Redirect Window Name: (No name) [ID: 0x%X]",
                             redirect_window);

	gtk_entry_set_text((GtkEntry*) entry_status_bar, r_win_name);

    executing = 0; // now unset flag to allow re-entry

    return TRUE;
}

