#ifndef KEYB_H
#define KEYB_H
/*
#include <libgnome/gnome-sound.h>
#include <libgnomeui/gnome-canvas.h>
#include <libgnomeui/gnome-canvas-text.h>
#include <libgnomeui/gnome-file-entry.h>
#include <libgnomeui/gnome-font-picker.h>
#include <libgnomeui/gtk-clock.h>
*/
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
//#include <gdk_imlib.h>
#include <stdio.h>
#include <X11/Xlib.h>


/* ********************
 * DEFINE
 * ********************/
#define KEYBOARD_VERSION "0.99"

// character
#define MAX_KEYNAME_LENGTH 15 //key name that would be obtained when 
							  //key is pressed on actual keyborad,
#define MAX_CHARS_ON_KEY 3
#define KEYBOARD_VW_LENGTH 	(7*MAX_CHARS_ON_KEY) 
							//arr length for storing chars on key, max 3 
							//a char in unicode may take 3 to (7) bytes	

//Remove this comment if want to change MAX_CHARS_ON_KEY 
//#define KEYBOARD_VW_LENGTH (MAX_CHARS_ON_KEY * 7)

#define KEYBOARD_OFF_SHIFT 0
#define KEYBOARD_OFF_CTRL 0
#define KEYBOARD_OFF_ALT 0
#define KEYBOARD_OFF_ALTGR 0
#define KEYBOARD_OFF_MODE_SWITCH 0

#define KEYBOARD_KEYS_MAX 103
 

/*********************
 * STRUCTURE             
 * *********************/

/*Every unicode character may take from 3 - 7 bytes we are allowing max of 
 * 3 character can be mapped by user in any lang to a key on keyboard amounting
 * to max of 21 bytes so length of KEYBOARD_VW_LENGTH = 21
 * 
*/

typedef struct
{
	gchar lower[KEYBOARD_VW_LENGTH], upper[KEYBOARD_VW_LENGTH];
		//storage of all laguages
	KeySym keysym_lower[MAX_CHARS_ON_KEY], keysym_upper[MAX_CHARS_ON_KEY];
	int no_lower, no_upper; //How many chars with & without shift mapped to key
	//lower -> without shift mapped to key 			( out of max MAX_C_O_K chars )
	//s -> with shift mapped to key				( ==  ||  ==  )
} lang_map;

/* First all laguage files would be read and so may 2d lang_map arrays would
 * be created and depending on current language an 1d array would be copied 
 * to keys[i].lang 
 */

// character flag
typedef enum {
	KEYBOARD_KEYS,
	KEYBOARD_SPACE,
    KEYBOARD_BACKSPACE,
	KEYBOARD_RETURN,
	KEYBOARD_ESCAPE,
	KEYBOARD_ETC
} KeyFlag;

typedef struct
{
	KeyFlag kflag;		//Flag indicating key type
	GtkWidget *button;	//Button widget for this key
	GtkWidget *entry;	//Entry widget for this key
	gchar kname1[MAX_KEYNAME_LENGTH], kname2[MAX_KEYNAME_LENGTH]; 
		//kname identifier with and with shift button press Same name 
		//can be obtained when we key is pressed on actual keyboard.
	lang_map lang; //current language binding This would change
				   //when would chage (need to copy) when laguage 
				   //type changes.
	guint16 keycode;	//Keycode for this key 
					//would be loaded depending on keyboard.
} key;


#define NO_OF_KEYS 80

#define KEY_DUMMY 0

#define KEY_A 1
#define KEY_B 2
#define KEY_C 3
#define KEY_D 4
#define KEY_E 5
#define KEY_F 6
#define KEY_G 7
#define KEY_H 8
#define KEY_I 9
#define KEY_J 10
#define KEY_K 11
#define KEY_L 12
#define KEY_M 13
#define KEY_N 14
#define KEY_O 15
#define KEY_P 16
#define KEY_Q 17
#define KEY_R 18
#define KEY_S 19
#define KEY_T 20
#define KEY_U 21
#define KEY_V 22
#define KEY_W 23
#define KEY_X 24
#define KEY_Y 25
#define KEY_Z 26

#define KEY_0 27 
#define KEY_1 28
#define KEY_2 29
#define KEY_3 30
#define KEY_4 31
#define KEY_5 32
#define KEY_6 33
#define KEY_7 34
#define KEY_8 35
#define KEY_9 36

#define KEY_ESC 37

#define KEY_F1 38
#define KEY_F2 39
#define KEY_F3 40
#define KEY_F4 41
#define KEY_F5 42
#define KEY_F6 43
#define KEY_F7 44
#define KEY_F8 45
#define KEY_F9 46
#define KEY_F10 47
#define KEY_F11 48
#define KEY_F12 49

#define KEY_TILDE 50
#define KEY_MINUS 51
#define KEY_EQUAL 52
#define KEY_BACKSPACE 53

#define KEY_OPENBRACKET 54
#define KEY_CLOSEBRACKET 55
#define KEY_BACKSLASH 56

#define KEY_SEMICOLON 57
#define KEY_QUOTE 58
#define KEY_ENTER 59

#define KEY_LEFTSHIFT 60
#define KEY_COMMA 61
#define KEY_POINT 62
#define KEY_SLASH 63
#define KEY_RIGHTSHIFT 64

#define KEY_LEFTCTRL 65
#define KEY_LEFTALT 66
#define KEY_SPACE 67
#define KEY_RIGHTCTRL 68
#define KEY_RIGHTALT 69

#define KEY_INSERT 70
#define KEY_HOME 71
#define KEY_PAGEUP 72
#define KEY_DELETE 73
#define KEY_END 74
#define KEY_PAGEDOWN 75

#define KEY_UPARROW 76
#define KEY_LEFTARROW 77
#define KEY_DOWNARROW 78
#define KEY_RIGHTARROW 79

#define KEY_PAGEKEYSTART 70
#define KEY_PAGEKEYEND 79

#define KEY_COUNT_START 1
#define KEY_COUNT_END 79

key **allKeys; //Storage of all languages keys 
char **langNames;
int no_of_langs;
char cur_lang[200]; //Current language
int cur_lang_id; //Current lang id in allKeys
int ulangchange; //to check if entries are manipulated due to 
					//menu item change and not manially since 
					//entry_change event should be called only when
					//its manual manipulation in user type

key keys[NO_OF_KEYS]; //Current language keys
					  //Only alphabetic/numeric/punctuation keys differ.

void getModifiableKeyIds(int *entryarr);
					//gives back the array of indices of modifiable keys
					//in entryarr
int isModifiableKeys_code(guint16 kcode);
					//Checks if the hardware keycode is amoungs 
					//modifiable keys i.e. KEY_A - KEY_Z 0-9 ,./[] etc.
					//if yes returns its keyid else 9999

GtkWidget *topWindow;
GtkWidget *entriesHBox;	//pointer to entries box for hide & show
GtkWidget *topVBox; //pointer to main v box to resize it when 
					//entries window is hidden or shown
gint tWinh, tWinw;	//Hight & width of top window
gint tVBh, tVBw, eHBh, eHBw;	//get this initially to calculate ratios
float win_h_ratio, win_w_ratio;	//To maintain the ratio width & height 
							// differences when entriesbox is hidden or shown. //with respect to window
float vbox_h_ratio, vbox_w_ratio; // with respect to vbox 
int isHideEntry;
int isHideStatusBar;

///GtkWidget *cursor_pad; //Pointer to cursor pad

gint sbWidth, sbHeight;

GtkWidget *entryShift,rightShift,leftShift;
GtkWidget *entrySave;

gboolean shifttoggled;	//shift toggle shift key status while in entry mode
gboolean shift;  	//When shift key or ctrl key on actual keyboard is pressed.

gint kb_total_key;
gint kb_state,ctrl,alt;

void mapKeys();
/* Get all (windows, buttons, entries, menu, menuitems, boxex[to show/hide
 * perticular window portion] pointers.
 * Also intializes some variables.
*/

void signalsConnect();
/*	Connects all buttons press, mouse click, entry change signals
 *	to their corrosponding callbacks.
 */

int button_key_press_callback (GtkButton *button, 
		                GdkEvent *event, key *cur_k);
/*	
 */

int button_key_release_callback (GtkButton *button, 
		                GdkEvent *event, key *cur_k);

gboolean topWindow_key_press_callback(GtkWidget *window, 
               GdkEventKey *event, gpointer user_data);
/*	called when focus is on eazykeyboard (application window) and 
 *  key is pressed on physical keyboard.
 */

gboolean topWindow_key_release_callback(GtkWidget *window, 
               GdkEventKey *event, gpointer user_data);
/*	called when focus is on eazykeyboard (application window) and 
 *  key is released on physical keyboard.
 */

int key_b_entry_changed_callback(GtkEditable *editable, key *cur_k);
void showEntries();
void hideEntries();

void key_press_shift();
void key_release_shift();

GSList *lang_menu_group;
GtkWidget *langMenuBar;
GtkWidget *langMenu;
GtkWidget **lang_menu_items;

void setLangMenu();
void language_changed_callback(GtkMenuItem *menuitem,
					gpointer user_data);
					//gpointer user_data, char *langname);

GdkFilterReturn pickNewKeyboardMap(GdkXEvent *xevent,
							GdkEvent *event,
							gpointer data);

GtkWidget *show_entry_box;	//entry check menu button
GtkWidget *show_status_bar; //status check menu button
GtkWidget *entry_status_bar; //status bar
GtkWidget *set_input_focus; //Input focus 
///GtkWidget *show_cursor_pad;

void showStatusBar();
void hideStatusBar();

static Time fake_timestamp();
void setKeysymSpecialKeys();

GtkWidget* help_about; //About dialog

void defaultKeyboard(); //Map keyboard from memory

GtkWidget *cursorEntryWidget;

int max_keycode, min_keycode; //Max and Min keycodes in system 
/* We load user(other than system) lang chars in system after the
 * max_keycode of system whenever language change is made So other
 * langs can work without much change.	
 */

int group; 	//active group (0 - 3)
			//Indicate in case of system type which 
			//keysym to used from keysym array for a keycode
			//In system keyboard map more than one languages could
			//be present. Current is defined by group code which is 
			//13th & 14th bit in key_state of keypress event.


/*Tracking redirect window*/
Window keyboard_window;
Window last_found_window;
Window redirect_window;
gint track_focus(gpointer data); /* Window focus tracking */

#endif // KEYB_H
