#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <glib/gunicode.h>
#include <locale.h>
#include <sys/stat.h>
#include <string.h>
#include "kboard.h"
#include "loadLanguage.h"


/* Now reading from only one perticular current language file and 
 * copying it to keys.  MODIFY TO FOLLOWING
 * Read no of langs and create 2d array of key for all languages 
 * 	(This will loaded once and also do respective computation for keysym
 *   also check if no of chars is not more than limit currently MAX_CHARS_ON_KEY(3) )
 *  
 * After this for current language copy all it respectives key from array
 * to keys[] so its now the current one and load this to button labels. 
 */

void loadLanguages() {
	char currentLang[300], lang[300], langfile[300];
	char dummy[500];
	char keyid[200], withoutshift[200], withshift[200];
	
	int i, j, no_keymaps, kid;
	gboolean filefound = FALSE;

	FILE *fp_allLang, *fp_lang;
	char filename[200], filename2[200];
	
	setKeymapPath(); //sets the mapping files path into keymap_path
	strcpy(filename, keymap_path);
	strcat(filename, "Languages.txt");
	
	if ( (fp_allLang = fopen(filename,"r")) == NULL)	{
		printf("\nWarning: Can not open file \"Languages.txt\" \n");
		no_of_langs = 0;
		// return;
	}
	else
	{
		fscanf(fp_allLang, "%d", &no_of_langs);
	}

	no_of_langs = no_of_langs + 1; //1 more to account for system mapping

	allKeys = (key**) malloc(no_of_langs * sizeof(key *));
	for(i=0; i<no_of_langs; i++) {
		allKeys[i] = (key*) malloc(NO_OF_KEYS * sizeof(key));
	}

	langNames = (char**) malloc(no_of_langs * sizeof(char *));
	for(i=0; i<no_of_langs; i++) {
		langNames[i] = (char*) malloc(200 * sizeof(char));
	}

	for(i=0; i<no_of_langs; i++) {				
			
		if(i == 0) { //First should be system mapped keyboard
			strcpy(langNames[i], "System");	
			//We are not mapping anything into allKeys[0] (system)
			//It will directly be mapping to keys whenever 
			//default keyboard map is obtained.
			strcpy(cur_lang, "System");
			cur_lang_id = i;
			continue;
		}
		
		fscanf(fp_allLang,"%s %s",lang, langfile); 
		strcpy(filename2, keymap_path);
		strcat(filename2, langfile);
		if( (fp_lang = fopen(filename2, "r")) == NULL) {
			printf("\nCan not open file \" %s \" \n",langfile);
			return;
		}
		strcpy(langNames[i], lang);
				
		fscanf(fp_lang,"%d",&no_keymaps);

		for(j=0; j<no_keymaps; j++) {
			fscanf(fp_lang,"%s %s %s",keyid,withoutshift,withshift);
			
			if (! strcasecmp(withoutshift, "null"))
				strcpy(withoutshift, "");
			if (! strcasecmp(withshift, "null"))
				strcpy(withshift, "");
			///printf("%s 1 %s 1 %s 1\n",keyid,withoutshift,withshift);
			kid = getKeyid(keyid);
		
			if(kid == 9999) {
				printf("check language file \" %s \" \n",langfile);
				printf("\nError : \"%s  %s  %s \" \n",keyid,
											withoutshift, withshift);
				return;
			}
			
			g_utf8_strncpy(allKeys[i][kid].lang.lower, withoutshift, MAX_CHARS_ON_KEY);
			
			g_utf8_strncpy(allKeys[i][kid].lang.upper, withshift, MAX_CHARS_ON_KEY);
			///strcpy(allKeys[i][kid].lang.lower, withoutshift);
			///strcpy(allKeys[i][kid].lang.upper, withshift);
			/*gtk_button_set_label((GtkButton*) keys[kid].button, 
											(gchar*)withoutshift);*/
		}

		fclose(fp_lang);
	}

	if (fp_allLang)	
		fclose(fp_allLang);
	
	setAllKeysyms();
/*	printf("\nNo of langs = %d\n",no_of_langs);
	for(i=0; i<no_of_langs; i++)
		printf("%s\n",langNames[i]);
*/
    	cur_lang_id = 0;
    	strcpy(cur_lang, langNames[0]);
	setCurrentLang(cur_lang_id); //Current lang is first lang //System
	setLangMenu();
}

int getKeyid(char *keyname) {

	if(strcmp(keyname, "KEY_A") == 0)
		return KEY_A;
	else if(strcmp(keyname, "KEY_B") == 0)
		return KEY_B;
	else if(strcmp(keyname, "KEY_C") == 0)
		return KEY_C;
	else if(strcmp(keyname, "KEY_D") == 0)
		return KEY_D;
	else if(strcmp(keyname, "KEY_E") == 0)
		return KEY_E;
	else if(strcmp(keyname, "KEY_F") == 0)
		return KEY_F;
	else if(strcmp(keyname, "KEY_G") == 0)
		return KEY_G;
	else if(strcmp(keyname, "KEY_H") == 0)
		return KEY_H;
	else if(strcmp(keyname, "KEY_I") == 0)
		return KEY_I;
	else if(strcmp(keyname, "KEY_J") == 0)
		return KEY_J;
	else if(strcmp(keyname, "KEY_K") == 0)
		return KEY_K;
	else if(strcmp(keyname, "KEY_L") == 0)
		return KEY_L;
	else if(strcmp(keyname, "KEY_M") == 0)
		return KEY_M;
	else if(strcmp(keyname, "KEY_N") == 0)
		return KEY_N;
	else if(strcmp(keyname, "KEY_O") == 0)
		return KEY_O;
	else if(strcmp(keyname, "KEY_P") == 0)
		return KEY_P;
	else if(strcmp(keyname, "KEY_Q") == 0)
		return KEY_Q;
	else if(strcmp(keyname, "KEY_R") == 0)
		return KEY_R;
	else if(strcmp(keyname, "KEY_S") == 0)
		return KEY_S;
	else if(strcmp(keyname, "KEY_T") == 0)
		return KEY_T;
	else if(strcmp(keyname, "KEY_U") == 0)
		return KEY_U;
	else if(strcmp(keyname, "KEY_V") == 0)
		return KEY_V;
	else if(strcmp(keyname, "KEY_W") == 0)
		return KEY_W;
	else if(strcmp(keyname, "KEY_X") == 0)
		return KEY_X;
	else if(strcmp(keyname, "KEY_Y") == 0)
		return KEY_Y;
	else if(strcmp(keyname, "KEY_Z") == 0)
		return KEY_Z;	
	else if(strcmp(keyname, "KEY_0") == 0)
		return KEY_0;
	else if(strcmp(keyname, "KEY_1") == 0)
		return KEY_1;
	else if(strcmp(keyname, "KEY_2") == 0)
		return KEY_2;
	else if(strcmp(keyname, "KEY_3") == 0)
		return KEY_3;
	else if(strcmp(keyname, "KEY_4") == 0)
		return KEY_4;
	else if(strcmp(keyname, "KEY_5") == 0)
		return KEY_5;
	else if(strcmp(keyname, "KEY_6") == 0)
		return KEY_6;
	else if(strcmp(keyname, "KEY_7") == 0)
		return KEY_7;
	else if(strcmp(keyname, "KEY_8") == 0)
		return KEY_8;
	else if(strcmp(keyname, "KEY_9") == 0)
		return KEY_9;
	else if(strcmp(keyname, "KEY_TILDE") == 0)
		return KEY_TILDE;
	else if(strcmp(keyname, "KEY_MINUS") == 0)
		return KEY_MINUS;
	else if(strcmp(keyname, "KEY_EQUAL") == 0)
		return KEY_EQUAL;
	else if(strcmp(keyname, "KEY_OPENBRACKET") == 0)
		return KEY_OPENBRACKET;
	else if(strcmp(keyname, "KEY_CLOSEBRACKET") == 0)
		return KEY_CLOSEBRACKET;
	else if(strcmp(keyname, "KEY_BACKSLASH") == 0)
		return KEY_BACKSLASH;
	else if(strcmp(keyname, "KEY_SEMICOLON") == 0)
		return KEY_SEMICOLON;
	else if(strcmp(keyname, "KEY_QUOTE") == 0)
		return KEY_QUOTE;
	else if(strcmp(keyname, "KEY_COMMA") == 0)
		return KEY_COMMA;
	else if(strcmp(keyname, "KEY_POINT") == 0)
		return KEY_POINT;
	else if(strcmp(keyname, "KEY_SLASH") == 0)
		return KEY_SLASH;
	else {
		printf("Key name \" %s \" not found ", keyname);
		return 9999;
	}
}

void setAllKeysyms() {
	int i, j, k, l, entryarr[47], entryindex=0;
	glong len;
	gchar *p;
	gunichar uni;

    getModifiableKeyIds(entryarr);
    entryindex = 47;	
	
	for(i=0; i<no_of_langs; i++) {
		for(l=0; l<entryindex; l++) {
			j = entryarr[l];
			
			// Get length of string < MAX_CHARS_ON_KEY 
			len = g_utf8_strlen(allKeys[i][j].lang.lower, KEYBOARD_VW_LENGTH);
			
			//printf("%s len=%d  \n",allKeys[i][j].lang.lower, len); ///
			p = allKeys[i][j].lang.lower;
			
			for(k=0; k<len && k<MAX_CHARS_ON_KEY; k++) {
				
				uni = g_utf8_get_char(p);
				if (uni > 0xFF)
					uni = uni | 0x01000000;
				allKeys[i][j].lang.keysym_lower[k] = uni;
				
				p = g_utf8_find_next_char(p,
							//&allKeys[i][j].lang.lower[KEYBOARD_VW_LENGTH] );
							&allKeys[i][j].lang.lower[KEYBOARD_VW_LENGTH - 1] );
			}
			
			allKeys[i][j].lang.no_lower = len;
					
			len = g_utf8_strlen(allKeys[i][j].lang.upper, KEYBOARD_VW_LENGTH);
			
			///printf(" %s len=%d  ",allKeys[i][j].lang.upper, len); ///
			p = allKeys[i][j].lang.upper;
				
			for(k=0; k<len && k<MAX_CHARS_ON_KEY; k++) {
				uni = g_utf8_get_char(p);
				
				if (uni > 0xFF)
					uni = uni | 0x01000000;
				allKeys[i][j].lang.keysym_upper[k] = uni;	
				p = g_utf8_find_next_char(p,
							//&allKeys[i][j].lang.upper[KEYBOARD_VW_LENGTH] );
							&allKeys[i][j].lang.upper[KEYBOARD_VW_LENGTH - 1] );
			}
			allKeys[i][j].lang.no_upper = len;
			
		
		}
			
	}	
	
}

void setCurrentLang(int langid) {
	int i, j, k, entryarr[47], entryindex=0;
	KeySym ksym_to_sys_lo[85], ksym_to_sys_up[85], kindex_l=0, kindex_u=0;
   									//l-lower u-upper	
	for(i=0; i<85; i++) {
		ksym_to_sys_lo[i] = 0;
		ksym_to_sys_up[i] = 0;
	}
	/* In Memory keyboard mapping generally range is 8-255 of which upto 
	 * 170 (no of keys on keyboard) is used for actual memory keymaps 
	 * settings and remaining we are using to set our own keycode mapping
	 * hence we are changing from 171-255 i.e. 85 max chars can be set. 
	 *
	 * WE ARE ACTULLY SEETING OUR KEYCODES IN SYSYTEM KEYBOARD MEM ITSELF
	 * SO THAT ANY LANG CAN WORK.
	 */

	if(langid >= no_of_langs) {
		printf("\nError : in setCurrentLang\n");
		return;
	}

	ulangchange = TRUE;

	if(! strcmp(langNames[langid], "System")) {
		gtk_widget_set_sensitive((GtkWidget*)show_entry_box, FALSE);
		hideEntries();
		ulangchange = FALSE;
		defaultKeyboard();
		return;
	}
	
	getModifiableKeyIds(entryarr);
	entryindex = 47;
	///printf("\n\n COPYING \n\n");
	for(j=0; j<entryindex; j++) {
		i = entryarr[j];				
		g_utf8_strncpy(keys[i].lang.lower, allKeys[langid][i].lang.lower, MAX_CHARS_ON_KEY);
		
		///printf("%s  %s \n",allKeys[langid][i].lang.lower, keys[i].lang.lower);
		g_utf8_strncpy(keys[i].lang.upper, allKeys[langid][i].lang.upper, MAX_CHARS_ON_KEY);
		
		keys[i].lang.no_lower = allKeys[langid][i].lang.no_lower;
		keys[i].lang.no_upper = allKeys[langid][i].lang.no_upper;
		
		for(k=0; k<keys[i].lang.no_lower; k++) {
			keys[i].lang.keysym_lower[k] = allKeys[langid][i].lang.keysym_lower[k];
			//append to keysym list in not already present if appended increment index.
			//printf("In addToKsymList keysym=0x%X index=0x%X \n",keys[i].lang.keysym_lower[k], kindex_l); 
			if(addToKsymList(ksym_to_sys_lo, keys[i].lang.keysym_lower[k], kindex_l)) {
				//printf("In addToKsymList keysym=0x%X index=0x%X \n",keys[i].lang.keysym_lower[k], kindex_l); 
				kindex_l += 1;
			}
		}
		
		for(k=0; k<keys[i].lang.no_upper; k++) {
			keys[i].lang.keysym_upper[k] = allKeys[langid][i].lang.keysym_upper[k];	
			//append to keysym list in not already present if appended increment index.
			if(addToKsymList(ksym_to_sys_up, keys[i].lang.keysym_upper[k], kindex_u))
				kindex_u += 1;
		}

		gtk_button_set_label((GtkButton*) keys[i].button, 
											(gchar*)keys[i].lang.lower);
		
		if( strcasecmp(langNames[langid], "user") == 0 &&
			gtk_toggle_button_get_active((GtkToggleButton*) entryShift) )
			gtk_button_set_label((GtkButton*) keys[i].button, (gchar*)keys[i].lang.upper);
		
		/*printf("%s	%s 	nkeysym=%d\n",allKeys[langid][i].lang.lower, 
					keys[i].lang.lower, keys[i].lang.no_lower);*/ 

		if(strcasecmp(langNames[langid], "user") == 0 ) { //if user type 
			///printf("%s	%s 	nkeysym=%d\n\n",allKeys[langid][i].lang.upper, 
			///keys[i].lang.upper, keys[i].lang.no_upper);
			if( gtk_toggle_button_get_active((GtkToggleButton*) entryShift) )
				gtk_entry_set_text((GtkEntry*) keys[i].entry, (gchar*)keys[i].lang.upper);
			else
				gtk_entry_set_text((GtkEntry*) keys[i].entry, (gchar*)keys[i].lang.lower);	
		}
	}
		
	{	
		//Now append these new keysyms after the max_keycode in system
		int ksymindex = (kindex_l>kindex_u ? kindex_l:kindex_u);
		KeySym *toSys = (KeySym*) malloc(2 * ksymindex * sizeof(KeySym));
		for(i=0; i<ksymindex; i++) 
		{
			toSys[2*i] = ksym_to_sys_lo[i];
			toSys[2*i+1] = ksym_to_sys_up[i];
		}
		
		//printf("GOINT TO CHANGE max=%d index=%d\n", 171, ksymindex+1);
		XChangeKeyboardMapping(GDK_DISPLAY(), 171, 2, toSys, ksymindex+1);
		//printf("AFTER CHANGE\n");
	}

	if(gtk_toggle_button_get_active(keys[KEY_LEFTSHIFT].button))
		gtk_toggle_button_set_active(keys[KEY_LEFTSHIFT].button,FALSE);
	if(gtk_toggle_button_get_active(keys[KEY_RIGHTSHIFT].button)) 
		gtk_toggle_button_set_active(keys[KEY_RIGHTSHIFT].button,FALSE);

	
	if(strcasecmp(langNames[langid], "user") == 0 )  
	{//if user type
		gtk_widget_set_sensitive((GtkWidget*)show_entry_box, TRUE);
		gtk_widget_set_sensitive(keys[KEY_LEFTSHIFT].button, FALSE);
		gtk_widget_set_sensitive(keys[KEY_RIGHTSHIFT].button, FALSE);
		showEntries();
	}
	else 
	{
		gtk_widget_set_sensitive((GtkWidget*)show_entry_box, FALSE);
		gtk_widget_set_sensitive(keys[KEY_LEFTSHIFT].button, TRUE);
		gtk_widget_set_sensitive(keys[KEY_RIGHTSHIFT].button, TRUE);
		hideEntries();
	}
	
	ulangchange = FALSE;
/*	
	for(j=0; j<entryindex; j++) {
		i = entryarr[j];
		printf("\n%s	nkeysym=%d	",keys[i].lang.upper, keys[i].lang.no_upper);
		for(k=0; k<keys[i].lang.no_upper; k++)
			printf("0x%X	",keys[i].lang.keysym_upper[k]);
	}
*/
}

int addToKsymList(KeySym *ksymList, KeySym keysym, int index) {
	//printf("In addToKsymList keysym=0x%X index=%d \n",keysym,index); 
	if(index > 84) return 0; 
	if(index == 0) {
		ksymList[index] = keysym;
		return 1;
	}
	else {
		int i=0;
		for(i=0; i<index; i++) 
			if(ksymList[i] == keysym) return 0; //its already there 

		ksymList[index] = keysym;
		return 1;
	}
}

void writeUserLang() {
	char filename3[200];
	strcpy(filename3, keymap_path);
	strcat(filename3, "userLang.txt");
	
	FILE *fp = fopen(filename3, "w");
	fprintf(fp, "%d\n", 47);
	fprintf(fp, "%s	%s	%s\n", "KEY_A", keys[KEY_A].lang.lower, keys[KEY_A].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_B", keys[KEY_B].lang.lower, keys[KEY_B].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_C", keys[KEY_C].lang.lower, keys[KEY_C].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_D", keys[KEY_D].lang.lower, keys[KEY_D].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_E", keys[KEY_E].lang.lower, keys[KEY_E].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_F", keys[KEY_F].lang.lower, keys[KEY_F].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_G", keys[KEY_G].lang.lower, keys[KEY_G].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_H", keys[KEY_H].lang.lower, keys[KEY_H].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_I", keys[KEY_I].lang.lower, keys[KEY_I].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_J", keys[KEY_J].lang.lower, keys[KEY_J].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_K", keys[KEY_K].lang.lower, keys[KEY_K].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_L", keys[KEY_L].lang.lower, keys[KEY_L].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_M", keys[KEY_M].lang.lower, keys[KEY_M].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_N", keys[KEY_N].lang.lower, keys[KEY_N].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_O", keys[KEY_O].lang.lower, keys[KEY_O].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_P", keys[KEY_P].lang.lower, keys[KEY_P].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_Q", keys[KEY_Q].lang.lower, keys[KEY_Q].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_R", keys[KEY_R].lang.lower, keys[KEY_R].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_S", keys[KEY_S].lang.lower, keys[KEY_S].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_T", keys[KEY_T].lang.lower, keys[KEY_T].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_U", keys[KEY_U].lang.lower, keys[KEY_U].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_V", keys[KEY_V].lang.lower, keys[KEY_V].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_W", keys[KEY_W].lang.lower, keys[KEY_W].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_X", keys[KEY_X].lang.lower, keys[KEY_X].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_Y", keys[KEY_Y].lang.lower, keys[KEY_Y].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_Z", keys[KEY_Z].lang.lower, keys[KEY_Z].lang.upper);
	
	fprintf(fp, "%s	%s	%s\n", "KEY_0", keys[KEY_0].lang.lower, keys[KEY_0].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_1", keys[KEY_1].lang.lower, keys[KEY_1].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_2", keys[KEY_2].lang.lower, keys[KEY_2].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_3", keys[KEY_3].lang.lower, keys[KEY_3].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_4", keys[KEY_4].lang.lower, keys[KEY_4].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_5", keys[KEY_5].lang.lower, keys[KEY_5].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_6", keys[KEY_6].lang.lower, keys[KEY_6].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_7", keys[KEY_7].lang.lower, keys[KEY_7].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_8", keys[KEY_8].lang.lower, keys[KEY_8].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_9", keys[KEY_9].lang.lower, keys[KEY_9].lang.upper);
	
	fprintf(fp, "%s	%s	%s\n", "KEY_TILDE", keys[KEY_TILDE].lang.lower, keys[KEY_TILDE].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_MINUS", keys[KEY_MINUS].lang.lower, keys[KEY_MINUS].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_EQUAL", keys[KEY_EQUAL].lang.lower, keys[KEY_EQUAL].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_OPENBRACKET", keys[KEY_OPENBRACKET].lang.lower, keys[KEY_OPENBRACKET].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_CLOSEBRACKET", keys[KEY_CLOSEBRACKET].lang.lower, keys[KEY_CLOSEBRACKET].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_BACKSLASH", keys[KEY_BACKSLASH].lang.lower, keys[KEY_BACKSLASH].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_SEMICOLON", keys[KEY_SEMICOLON].lang.lower, keys[KEY_SEMICOLON].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_QUOTE", keys[KEY_QUOTE].lang.lower, keys[KEY_QUOTE].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_COMMA", keys[KEY_COMMA].lang.lower, keys[KEY_COMMA].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_POINT", keys[KEY_POINT].lang.lower, keys[KEY_POINT].lang.upper);
	fprintf(fp, "%s	%s	%s\n", "KEY_SLASH", keys[KEY_SLASH].lang.lower, keys[KEY_SLASH].lang.upper);

	fclose(fp);
}

void setKeymapPath() {
	char *user_eazykeyboard_dir, user_eazykeyboard_path[128];
	char *local_dir, local_data_path[128];
	struct stat buf;
	char global_dir[128], global_data_path[128];
	char cmd[100];

#ifndef PACKAGE_DATA_DIR
	#define PACKAGE_DATA_DIR /usr/share
#endif
	
	strcpy(global_dir, PACKAGE_DATA_DIR);
	strcpy(global_data_path, global_dir);
	strcat(global_data_path, "/eazykeyboard/keymaps/");

    local_dir = getenv("HOME");
    strcpy(local_data_path, local_dir);
    strcat(local_data_path, "/.eazykeyboard/");

    if (stat(local_data_path, &buf) == -1) {
		fprintf(stdout, "Creating local directory...\n");
		sprintf(cmd, "mkdir %s", local_data_path);
        if( system(cmd) != -1) {
	        fprintf(stdout, "Copying files...\n");
			sprintf(cmd, "cp %s/* %s", global_data_path, local_data_path);
	        system(cmd);
	    }
	}
	
    /* check for user_path set through environment variable */
    user_eazykeyboard_dir = getenv("EAZYKEYBOARD_DATA_PATH");
    
    if (user_eazykeyboard_dir) {
	    strcpy(user_eazykeyboard_path, user_eazykeyboard_dir);
		
	    if ( (strcmp(user_eazykeyboard_path, "") == 0 ||
              user_eazykeyboard_path[strlen(user_eazykeyboard_path)-1] != '/') )
             strcat(user_eazykeyboard_path, "/");
    }
		
    if (stat(user_eazykeyboard_path, &buf) != -1) {
		strcpy(keymap_path, user_eazykeyboard_path);
    }
    else
    /* check for local path */
    if (stat(local_data_path, &buf) != -1) {
        strcpy(keymap_path, local_data_path);
    }
    else
    /* check for global path */
    if (stat(global_data_path, &buf) != -1) {
       strcpy(keymap_path, global_data_path);
    }
	else {
       fprintf(stdout, "*Error* Can't read keyboard config file");
       exit(1);
    }
		
    fprintf(stdout, "keymap_path=%s\n", keymap_path);
    fflush(stdout);	
}
